//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

function BlogAPIDetector() {
}

BlogAPIDetector.prototype = 
{
    _req: null,
    _title: null,

    getTitle: function()
    {
        return this._title;
    },
    doRequest: function(listener, url, processor)
    {
        var inst = this;
        this._req = new XMLHttpRequest();
        this._req.onreadystatechange = function (aEvt) 
        {
            try
            {
                if(inst._req.readyState == 4) 
                {
                    if(inst._req.status == 200)
                    {
                        dump(inst._req.responseText + "\n");
                        try
                        {
                            var result = processor(listener, inst)
                        }
                        catch(e)
                        {
                            listener.onError(e);
                        }
                    }
                    else
                    {
                        listener.onError(inst._req.status);
                    }
                }
            }
            catch(e)
            {
                listener.onError(-1);
            }
        };
        this._req.open('GET', url, true);
        this._req.send(null); 
    },
    detect: function(listener, url)
    {
        this.doRequest(listener, url, this.onHomePage);
    },
    onHomePage: function (listener, inst)
    {
        /*
         * The following code is to clean up shitty html to make it parser
           friendly
         */

        var req = inst._req;          
        var text = req.responseText;
        text = text.replace(/[\r\n]/g,"");
        
        if(text.match(/<title.*>(.+?)</))
        {
            inst._title = RegExp.$1;
        }

        var linkObj = function () {
        }

        linkObj.prototype = {
            href:null,
            rel:null,
            type:null,
            title:null,
        }

        var linklist = new Array();

        var R = /<link.+?>/g;
        for(;;)
        {
            var ar = R.exec(text);
            if(!ar) break;
            var cur = ar[0] + "";
            var link = new linkObj();
            if(cur.match(/href=\"(.+?)\"/)) {
                link.href = RegExp.$1;
            }
            if(cur.match(/rel=\"(.+?)\"/)) {
                link.rel = RegExp.$1;
            }
            if(cur.match(/title=\"(.+?)\"/)) {
                link.title = RegExp.$1;
            }
            if(cur.match(/type=\"(.+?)\"/)) {
                link.type = RegExp.$1;
            }
            linklist.push(link);
        }

        for(var i=0;i<linklist.length;++i)
        {
            var link = linklist[i]; 
            var url = link.href;
            if(!url) continue;
            //alert(url);

            if(link.type=="application/atom+xml" && link.rel=="service.post")
            {
                /*
                 * Blogger Atom API, what else
                 */

                var rval = new Array();
                var B = new AtomAPI();
                B.init("atom", "", url, "", "", "");
                rval[0] = B;
                listener.onAPI(rval);
                return;
            }
            else if(link.rel=="pingback")
            {
                /*
                 * Wordpress, what else
                 */
                var rval = new Array();
                var B = new MovableTypeAPI();
                B.init("movabletype", "", url, "", "", "");
                rval[0] = B;
                listener.onAPI(rval);
                return;

            }
            else if(link.title=="RSD" || link.type=="application/rsd+xml")
            {
                /*
                 * Blogger xml-rpc service discovery
                 */
                inst.doRequest(listener, url, inst.onIntrospect);
                return;
            }
        }
        listener.onAPI(null);
    },
    onIntrospect: function (listener, inst)
    {
        try
        {
            var req = inst._req;

            var dom = req.responseXML;
            if(!dom) {
                var parser = new DOMParser();
                dom = parser.parseFromString(req.responseText,"text/xml");
            }
            var apis = dom.getElementsByTagName("api");

            var rval = new Array();
            for(var i=0;i<apis.length;++i)
            {
                var name = apis[i].getAttribute("name").toLowerCase();
                name = name.replace(/\s/g,"");//remove spaces

                if(name=="atom") continue;

                var apiLink = apis[i].getAttribute("apiLink");
                var preferred = apis[i].getAttribute("preferred").toLowerCase();
                var blogID = apis[i].getAttribute("blogID");
                var B = null;
                if(name=="blogger") {
                    B = new BloggerAPI();
                }
                if(name=="metaweblog") {
                    B = new MetaweblogAPI();
                }
                if(name=="movabletype") {
                    B = new MovableTypeAPI();
                }
                if(B==null) continue;
                B.init(name, "", apiLink, blogID, preferred);
                rval[rval.length] = B;
            }
            listener.onAPI(rval);
        } 
        catch(e) {
            listener.onError("RSD Parsing Error");
            //alert(e + " " + e.fileName + " " + e.lineNumber);
        }
    },
}
