// // BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var gNewBlogAccount = null;
var gB = null;
var gDetect = null;

function flock_blogWizardLoad()
{
    flock_blogGetSettings();
    gNewBlogAccount = new BlogAccount("ignore");
    if(window.arguments && window.arguments.length)
    {
        var arg = window.arguments[0];
        $("blog-wizard-url").value = arg;
        $("blogAccountWizard").advance();
    }
}

function fillFinalUI2(api)
{
    $("blog-username").value = gNewBlogAccount.username;
    $("blog-password").value = gNewBlogAccount.password;
    $("blog-uri").value =  api.apiLink;

    var blogid = api.blogID;
    if(api.blogID.length==0) api.blogID = "1";
    $("blog-blogid").value =  blogid;
}

function fillFinalUI()
{
    if(gB)
    {
        $("blog-api-menu").value = gB.name;
        fillFinalUI2(gB);
    }
}

function blogWizardStartShow() {
    $("blogAccountWizard").canAdvance = true;
    $("blogAccountWizard").canRewind = false;
    $('blog-wizard-url').select();
}

function blogWizardStartAdvance()
{
    //flock_blogInitRDF();
    gNewBlogAccount.blogURL = $("blog-wizard-url").value;
    gB = null;
    gDetect = new BlogAPIDetector();
    try
    {
        gDetect.detect(new detectListener(), gNewBlogAccount.blogURL);
        $("blogAccountWizard").canAdvance = false;
        $("blogAccountWizard").canRewind = false;
    }
    catch(e)
    {
        var msg = flock_blogBundle().GetStringFromName("blog_wizard_invalidurl");
        alert(msg);
        throw new Error("Musn't advance");
    }
}

function blogAccountWizardSelectAPI(aAPIName) {
    dump(aAPIName + "<<<\n");
    if(aAPIName=="unknown") {
        $("blogAccountWizard").canAdvance = false;
    }
    else {
        $("blogAccountWizard").canAdvance = true;
    }
}

function blogWizardDetectAdvance()
{
    try
    {
        if(gB)
        {
            var label = flock_blogBundle().GetStringFromName("blog_wizard_apidetected_label");
            var msg = flock_blogBundle().GetStringFromName("blog_wizard_apidetected_msg");
            $("blogWizardConfirmSettings").setAttribute("label", label);
            $("blogWizardConfirmSettings").setAttribute("description", msg);
        }
        else
        {
            var label = flock_blogBundle().GetStringFromName("blog_wizard_config_label");
            var msg = flock_blogBundle().GetStringFromName("blog_wizard_config_msg");
            $("blogWizardConfirmSettings").setAttribute("label", label);
            $("blogWizardConfirmSettings").setAttribute("description", msg);
        }
    }
    catch(e)
    {
        alert(e);
    }

    fillFinalUI();
}

function blogWizardDetectRewind()
{
    //$("blogAccountWizard").rewind();
//    window.location.reload();
//    $("blogAccountWizard").canAdvance = true;
    window.stop();
    $("blogAccountWizard").goTo("blogWizardStart");
//    $("blogAccountWizard").goTo("blogWizardStart");
//    $("blog-wizard-url").select();
}


function doRestart() {
    $("blogAccountWizard").goTo("blogWizardStart");
    $("blogAccountWizard").rewind();
}

function blogWizardConfirmSettingsRewind() {
    window.setTimeout("doRestart();", 0);
}

function blogWizardConfirmSettingsAdvance()
{
    if(true || !gB)//should this be unconditional? - yes.
    {
        var name = $("blog-api-menu").value;
        var B = flock_blogCreateAPIFromName(name);
/*
        if(!B) {
            alert("Please select a blog account");
            //$("blogAccountWizard").rewind();
            return false;
        }
*/
/*

        if(name=="atom") {
            B = new AtomAPI();
        }
        if(name=="blogger") {
            B = new BloggerAPI();
        }
        if(name=="metaweblog") {
            B = new MetaweblogAPI();
        }
        if(name=="movabletype") {
            B = new MovableTypeAPI();
        }
*/

        B.init(name, "", $("blog-uri").value, $("blog-blogid").value, true);

        gB = B;
    }
}

function blogTitleAdvance() {
}

function blogWizardPasswordAdvance() {
    gNewBlogAccount.username = $("blog-wizard-user").value;
    gNewBlogAccount.password = $("blog-wizard-password").value;
    $("blog-username").value = gNewBlogAccount.username;
    $("blog-password").value = gNewBlogAccount.password;

    if(gB)
    {
        gB.setAuth(gNewBlogAccount.username,gNewBlogAccount.password);
        gB.getUsersBlogs(new flock_blogWizardUsersBlogsListener());//todo: make this a preference
        $("blogAccountWizard").canAdvance = false;
    }
}

function blogWizardTestAdvance() {
}

function blogOptionsAdvance() {
}

function blogWizardSaveAccount(aTitle, aAPIName, aAPILink, aBlogID, aEditLink)
{
    var blogSettings = flock_blogGetSettings();

    var title = aTitle;
    var count = 1;
    while(blogSettings.accountExists(title)) {
        title = aTitle + " (" + count + ")";
        ++count;
        if(blogSettings.accountExists(title)) continue;

	    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
        var out = {};
        out.value = title;
        var winTitle = "Blog name already in use";
        var winText = "You already have a blog account by this name in your list.\n\nPlease use a different name for this account, or click Cancel.";
	    var result = promptService.prompt(window, winTitle, winText, out, null, {});
        if(result) {
            title = out.value;
        }
        else {
            return;
        }
    }
        

    var account = new BlogAccount(title);
    var api = new BlogAPI();

    var username = $("blog-username").value;
    var password = $("blog-password").value;
    account.title = title;
    account.blogID = aBlogID;
    account.username = username;
    account.password = password;
    api.name = aAPIName;
    api.apiLink = aAPILink;
    api.editLink = aEditLink;
    api.blogID = aBlogID;
    account.url = $("blog-wizard-url").value;
    
    try {
        blogSettings.saveAccount(account);
        account.setBlogAPI(api);
        flock_blogSetDefaultAccount(title);
    }
    catch(e)
    {
        alert(e);
    }

//    blogSettings.addAPI(api);
//    var ds = flock_blogGetDS();
//    var bloguri = BLOG_URN_ROOT + title;
//    flock_blogRemoveSettings(bloguri);
//    var blogurl = $("blog-wizard-url").value;
//    flock_blogAddAccount(aTitle, u, p, true, blogurl);//this url is out of date
//    flock_blogAddAPI(aTitle, aAPIName, aAPILink, aBlogID);
}

function blogWizardFinalShow() {
    $("blogAccountWizard").canRewind = false;
    $("blogAccountWizard").getButton("cancel").setAttribute("hidden", true);
}

function blogWizardFinalAdvance() {
    /*
     * Here, go ahead and set the default account to be the last added account
     */
    //var blogSettings = flock_blogGetSettings();
    //var count = blogSettings.getAccountCount();
    //flock_blogSetDefaultAccountIndex(count-1);
    window.close();
}

function detectListener() {
}

detectListener.prototype = 
{
    onAPI: function(apis) 
    {
        // let us strongly prefer movabletype for now.
        for(var i=0;i<apis.length;++i) {
            if(apis[i].name=="movabletype") {
                gB = apis[i]; break;
            }
        }
        if(!gB) {
            for(var i=0;i<apis.length;++i) {
                if(apis[i].name=="movabletype") {
                    gB = apis[i]; break;
                }
                if(apis[i].name=="metaweblog") {
                    gB = apis[i]; break;
                }
                if(apis[i].name=="atom") {
                    gB = apis[i]; break;
                }
                if(apis[i].name=="blogger") {
                    gB = apis[i]; break;
                }
            }
        }

        fillFinalUI();

        if(gB.name=="atom") {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").canRewind = true;
            $("blog-nonatom-container").collapsed = true;
            $("blogAccountWizard").advance();
            $("blogAccountWizard").advance();
            $("blogAccountWizard").advance();
        }
        else {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").advance();
            $("blogAccountWizard").advance();
            //$("blogAccountWizard").advance();
        }

        return;

    },

    onError: function (errorMsg) 
    {
        var msg = flock_blogBundle().GetStringFromName("blog_wizard_detecterr");
        if(confirm(msg)) {
            $("blogAccountWizard").rewind();
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").canRewind = true;
        }
        else
        {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").advance();
        }

    }
};

function flock_blogWizardUsersBlogsListener()
{
}

function flock_blogWizardRemovePasswords(aHost) {
    var psm = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
    var enum = psm.enumerator;
    var toRemove = new Array();
    while(enum.hasMoreElements()) {
        var pw = enum.getNext();
        pw = pw.QueryInterface(Components.interfaces.nsIPassword);
        //if(pw.host==aHost && aUsername==pw.user) {
        if(pw.host==aHost) {
            toRemove[toRemove.length]==pw;
        }
    }

    for(var i=0;i<toRemove.length;++i) {
        try {
            psm.removeUser(pw.host, pw.user);
        } catch(e) { }
    }
    return null;
}

flock_blogWizardUsersBlogsListener.prototype = 
{
    redoAtom: function() {
        try {
            $("blogAccountWizard").goTo("blogWizardStart");
            //flock_blogWizardRemovePasswordsFromUrl(gB.apiLink);
            //gB.getUsersBlogs(this);
        }
        catch(e) {
            alert(e);
        }
    },
    onResult: function(result) 
    {
        // Return value: on success, array of structs containing String url, String blogid, String blogName; on failure, fault
        if(result.length==0) {
            this.onError();
            return;
        }
        gBlogs = new Array();
        for(var i=0;i<result.length;++i)
        {
            var url = result[i].url;
            var blogid = result[i].blogid;
            /*
            if(result.length==1) {
                blogid = $("blog-blogid").value;
            }
            */
            var blogName = result[i].blogName;
            var apiLink = gB.apiLink;
            var editLink = gB.editLink;
            if(!editLink) editLink = apiLink;
            if(gB.name=="atom") apiLink = url;// Atom uses a url model for posting
            var apiName = $("blog-api-menu").value;
            blogWizardSaveAccount(blogName, apiName, apiLink, blogid, editLink);
        }

        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").advance();
        return;

        var title = BLOG_URN_ROOT + $("blog-title").value;
        var loader = new flock_blogPostListingListener(title, 25);
        loader.didUpdate = true;
        loader.onResult(result);
        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").advance();
    },

    onFault: function (fault)
    {
        //Error
        var msg = flock_blogBundle().GetStringFromName("blog_wizard_detecterr2");
        alert(msg + "\n" + fault.faultString);
        if(gB.name=="atom") {
            this.redoAtom();
        }
        else {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").rewind();
        }
    },

    onError: function (error)
    {
        //Error
        var msg = flock_blogBundle().GetStringFromName("blog_wizard_detecterr2");
        alert(msg);
        if(gB.name=="atom") {
            this.redoAtom();
        }
        else {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").rewind();
        }
    }
}
