//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


///////////////////////////////////////////////////////////////// 
var gRefreshList = null;

function flock_error(e) {
    alert(e + " " + e.lineNumber + " " + e.fileName);
}

function flock_blogSetDefaultAccountIndex(i) {
    flock_setIntPref("flock.blog.defaultAccountIndex", i);
}

function flock_blogGetDefaultAccountIndex(i) {
    try {
        return flock_getIntPref("flock.blog.defaultAccountIndex");
    }
    catch(e) {
        return 0;
    }
}

function flock_blogBundle() {
    return flock_getStringBundle("chrome://flock/locale/blog/blog.properties");
}

function flock_blogSetDefaultAccount(acct) {
    flock_setCharPref("flock.blog.defaultAccount", acct);
}

function flock_blogGetDefaultAccount() {
    var defaultAccount = flock_getCharPref("flock.blog.defaultAccount");
    if(!defaultAccount) flock_setCharPref("flock.blog.defaultAccount", FLOCK_BLOG_DRAFTS_FOLDER);
    return flock_getCharPref("flock.blog.defaultAccount");
}


function flock_blogBuildBlogThisPostURI(postid) {
    //var url = "chrome://browser/content/flock/blog/blogEditor.xul"
    var url = "chrome://browser/content/flock/blog/tinyBlog.xul"

    if(index==null) index = 0;

    var index = 0;
    var selectedBlog = flock_blogGetDefaultAccount();

    var params = "?bloguri="; 
    params += hexEncode(selectedBlog) + "&selectedIndex=" + hexEncode(index);
    params += "&postid=" + hexEncode(postid);
    url += params;
    return url;
}

/////////////////////////////////////////////////////////////////
// A useful, shared command, ... or is it?
/////////////////////////////////////////////////////////////////

var flock_blogNewPostCommand =
{
    isEnabled: function() {
        return true;
    },
    exec: function() {
        var date = new Date();
        var postid = FLOCK_BLOG_RDF_TMP_POST;
        var url = flock_blogBuildBlogThisPostURI(postid);

        var blogPost = new BlogPost();
        var helperAccount = new BlogAccount();

        blogPost.title = FLOCK_BLOG_DEFAULT_TITLE;
        blogPost.uri = postid;
        blogPost.content = "&nbsp";
        blogPost.state = FLOCK_BLOG_STATE_NEW;
        blogPost.dateCreated = new Date();
        helperAccount.savePost(blogPost);
//        flock_blogSavePost(postid, null, "<p></p>", FLOCK_BLOG_STATE_NEW, new Date());
        flock_blogDoOpenPost(url);
        return;
    },
}


var flock_blogBlogThisCommand =
{
    target: null,
    isEnabled: function() {
        return true;
    },
    onDrop: function(aSource) {
        this.target = aSource;
        this.exec();
    },
    exec: function() {
        var date = new Date();
        var postid = FLOCK_BLOG_RDF_TMP_POST;
        var url = flock_blogBuildBlogThisPostURI(postid);

        var topWindow = flock_mostRecentNavigator();
        var node = null;

        if(topWindow.document.popupNode) {
            node = topWindow.document.popupNode;
        }
        else {
            node = this.target;//this is set by a drop handler in the topbar - crazy
        }

        var contentDetector = new nsContentDetector();
        contentDetector.setTarget(node);

        var selection = $$("content").mCurrentBrowser.contentWindow.getSelection() + "";
        var data = "";
        var location = $$("content").mCurrentBrowser.contentWindow.location + "";
        if(location.match(/^chrome:\/\/.+/)) {
            location = "";
        }
        var title = $$("content").mCurrentBrowser.contentTitle + "";

        if(contentDetector.onImage) {
            data = '<blockquote cite="' + location + '">' + '<img src="' + contentDetector.imageURL + '" />' + "</blockquote>";
            if(title.length==0) title = location;
            data += '<p class="citation"><cite cite="' + location + '"><a href="' + location + '">' + title + '</a>' + "</cite></p><p></p>";
        }
        else if(selection.length == 0) {
//            $$("content").mCurrentBrowser.contentWindow.location.spec;
            data = '<a href="' + location + '">' + title + "</a> <br/><br/>";
        }
        else {
            data = '<blockquote cite="' + location + '">' + selection + "</blockquote>";
            if(title.length==0) title = location;
            data += '<p class="citation"><cite cite="' + location + '"><a href="' + location + '">' + title + '</a>' + "</cite></p><p></p>";
        }
        data = data.replace(/\n/g,"");
        data = data.replace(/\r/g,"");

        var blogPost = new BlogPost();
        blogPost.title = FLOCK_BLOG_DEFAULT_TITLE;
        blogPost.uri = postid;
        blogPost.content = data + "<p></p>";
        blogPost.state = FLOCK_BLOG_STATE_NEW;
        blogPost.dateCreated = date;
        var helperAccount = new BlogAccount();
        helperAccount.savePost(blogPost);
        flock_blogDoOpenPost(url);
        return;
    },
}

var flock_blogCreateAccountCommand =
{
    isEnabled: function() {
        return true;
    },
    exec: function() {
        flock_blogOpenWizard();
    },
}

/////////////////////////////////////////////////////////////////
// Dialogs
/////////////////////////////////////////////////////////////////

function flock_blogDoOpenPost(aUrl) {
    try {
        if(flock_getBoolPref("flock.blog.editInTab")) {
            flock.browser.open(aUrl, "foreground_tab");
        }
        else {
            window.open(aUrl,"_blank", "chrome,close,titlebar,resizable=yes,toolbar=no,dialog=no,scrollbars=yes");
        }
    }
    catch(e) {
        window.openDialog(aUrl);
    }
}

function flock_blogGotoService() {
    flock_goto("http://www.flock.com/fiveways/togetstarted/with/blogging/");
}

function flock_blogOpenWizard(param) {
    var ugly = false;
    if(!param) ugly = true;
    if(!param) param = "";
    if(ugly) window.open("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "chrome,modal,centerscreen", param); 
    else window.openDialog("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "modal,centerscreen", param); 
}



/////////////////////////////////////////////////////////////////
// Other Helpers
/////////////////////////////////////////////////////////////////

function padDate(str) {
    str = str + "";
    if(str.length==1) return "0" + str;
    return str;
}

function padDateTime(str) {
    str = str + "";
    var diff = 16 - str.length;
    for(var i=0;i<diff;++i)
    {
        str = "0" + str;
    }
    return str;
}

function hexEncode(string) {
    string = String(string); // just to be sure
    var arr = [];
    for (var i=0 ; i<string.length ; i++) {
        arr[i]=toHexCode(string.charCodeAt(i));
    }
    return arr.join("");
}

function toHexCode(number) {
    var string = number.toString(16);
    if (string.length>2) { // pad with zeros to 2 or 4 positions
        return "\\u"+("00"+string).substring(string.length-2);
    } 
    else {
        return "\\x"+("00"+string).substring(string.length);
    }
}

function hexDecode(string) { // assumes format "\xDD\uDDDD\xDD"
    var arr = [];
    var re = /\\[ux]([\da-f]{2,4})/gi;
    while (match = re.exec(string)) {
        arr[arr.length] = String.fromCharCode(parseInt(match[1],16));
    }
    return arr.join("");
}

var flock_blogRefreshAccountCommand =
{
    isEnabled: function()
    {
        if(gSelectedBlog && gSelectedBlog.match(FLOCK_BLOG_DRAFTS_FOLDER)) return false;
        if(!gSelectedBlog) return false;
        return true;
    },
    exec: function()
    {
        var ds = flock_blogGetDS();
        var uri = gSelectedBlog + ":" + "posts";
        var posts = ds.getNode(uri);
        var postslist = posts.getChildren();
        var toDelete = new Array();
        var modCount = 0;
        while(postslist.hasMoreElements())
        {
            var post = postslist.getNext();
            state = post.getTarget(FLOCK_BLOG_NS+"state").getValue();
            if(state!=BLOG_STATE_NEW)
            {
                toDelete[toDelete.length] = post;
            }
            if(state==BLOG_STATE_CHANGED)
            {
                ++modCount;
            }
        }
        if(modCount)
        {
            if(!confirm("You have made local changes to some already published posts. \n\n Updating will delete these changes.  Are you sure you would like to continue?" ))
            {
                return;
            }
        }
        for(var i=0;i<toDelete.length;++i)
        {
            ds.deleteRecursive(toDelete[i]);
            posts.removeChild(toDelete[i]);
        }
        ds.save();

        gSelectedBlog.match(/.+:(.+)/);
        var title = RegExp.$1;
        window.openDialog("blogDownloadPosts.xul", "downloadPostsAccount", "modal", title); 

        ds.save();
    },
}

/////////////////////////////////////////////////////////////////
// Account Refreshing
/////////////////////////////////////////////////////////////////


function flock_blogRefreshList() {
    if(!gRefreshList) return;
    if(gRefreshList.length==0)
    {
        gRefreshList=null;
        return;
    }

    var nextAccount = gRefreshList.pop();
    var listener = new flock_blogPostListingListener(nextAccount, true);
    var blogSettings = flock_blogGetSettings();
    var B = blogSettings.getAccount(nextAccount).getBlogAPI();
    B.getRecentPosts(listener, BLOG_POST_DOWNLOAD_COUNT);
}

var flock_blogRefreshAllAccountsCommand =
{
    isEnabled: function()
    {
        return gRefreshList==null;

    },
    exec: function()
    {
        gRefreshList = new Array();
        var blogSettings = flock_blogGetSettings();
        var settings = blogSettings.getSettingsContainer();
        var accounts = settings.getChildren();
        while(accounts.hasMoreElements())
        {
            var account = accounts.getNext();
            var a = FLOCK_BLOG_RDF_SETTINGS + ":" + account.getTarget(FLOCK_BLOG_NS+"title").getValue();
            if(a==FLOCK_BLOG_DRAFTS_FOLDER) continue;

            gRefreshList[gRefreshList.length] = a;
        }
        flock_blogRefreshList();
    },
}

function flock_blogPostListingListener(selectedBlog, force_update) {
    this.selectedBlog = selectedBlog;
    this.force_update = force_update;
}

flock_blogPostListingListener.prototype = 
{
    selectedBlog: null,
    force_update: null,
    didUpdate: false,
    onResult: function(result) 
    {
        var blogSettings = flock_blogGetSettings();
        var account = blogSettings.getAccount(this.selectedBlog);
        if(!result)
        {
            return;
            alert("returning on parser error");
        }
        var data = result;
        var count = 0;
        for(var i=0;i<data.length;++i)
        {
            var posturi = this.selectedBlog + ":posts:" + data[i].postid;
            //alert(posturi);
            var date = new Date(data[i].dateCreated);

            if(!this.force_update && postExists(posturi)) {
                continue;
            }


            if(data[i].dateCreated) {
            }

            var mycontent = "";
            if(data[i].content)
            {
                mycontent = data[i].content;
            }

            if(data[i].description) {
                if(mycontent.length < data[i].description.length) mycontent = data[i].description;
            }

            if(data[i].mt_text_more)
            {
                mycontent += data[i].mt_text_more;
            }

            var title = data[i].title;

            if(!mycontent && !title) { continue; }

            mycontent = mycontent.replace(/\r/g,"");

            try {
                if(title==null && flock_getBoolPref(FLOCK_BLOG_PREF_TITLEISFIRSTLINE) == true) {
                    var lines = mycontent.split(/\n/);
                    title = lines.shift();
                    mycontent = lines.join("\n");
                }
            } catch(e) {
                //alert(e);
            }

            mycontent = mycontent.replace(/\r/g,"");
            mycontent = mycontent.replace(/\n/g,"<br/>");
            try {
                var postid = data[i].postid;
                var oldPost = account.getPost(postid);
                if(oldPost) account.deletePost(oldPost);
                var newPost = new BlogPost(this.selectedBlog, postid);
                if(data[i].editURI) newPost.editURI = data[i].editURI;
                if(data[i].atomid) newPost.atomid = data[i].atomid;
                newPost.title = title;
                newPost.content = mycontent;
                newPost.state = FLOCK_BLOG_STATE_OK;
                newPost.dateCreated = date;
                newPost.permaLink = data[i].permaLink;
                if(!newPost.permaLink) newPost.permaLink = data[i].kink;
                account.savePost(newPost, true);
            }
            catch(e)
            {
                alert(e + e.fileName + " " + e.lineNumber + "\n");
            }
        }
        account.setInitialized(1);
        this.doUpdate();
     },

     onFault: function (fault)
     {
        var msg = flock_blogBundle().GetStringFromName("blog_listing_fault");
        alert(msg + "\n\n" + fault.faultString);
//        alert("There was an error retrieving your blog posts from your service.\n Please check your account information and try again");
        this.doUpdate();
     },

     onError: function (error)
     {
        var msg = flock_blogBundle().GetStringFromName("blog_listing_error");
        alert(msg);
//        alert("There was an error retrieving your blog posts from your service.\n It's probably the case that you entered incorrect blog settings (like the API url)");
        this.doUpdate();
     },
     doUpdate: function (error)
     {
        if(this.didUpdate) return;
        didUpdate = true;
        flock_blogRefreshList();
     },
};

