//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gParams = null;
var gB = null;

function flock_blogTriggerPublish() {
    var blogSettings = flock_blogGetSettings();
    var blogAccount = blogSettings.getAccount(gParams.selectedBlog);
    gB = blogAccount.getBlogAPI();
    if(gParams.newPost) {
        var listener = BlogPublishListener;
        listener.selectedPost = gParams.selectedPost;
        gB.newPost(listener, gParams.title, gParams.html, gParams.date, gParams.publish);
    }
    else {
        var listener = BlogEditListener;
        listener.selectedPost = gParams.selectedPost;
//        alert(gParams.selectedPost);
//var blogPost = blogAccount.getPostByURI(gParams.selectedPost);
//        alert(blogPost.editURI);
//    alert(gParams.editURI + "<jj<<<<<<" + gParams.atomid);
        gB.editPost(listener, gParams.postid, gParams.title, gParams.html, gParams.date, gParams.publish, gParams.editURI, gParams.atomid); }
}

function flock_blogTriggerEdit() {
}

function flock_blogPublishLoad() {
    if(window.arguments && window.arguments.length) {
        gParams  = window.arguments[0];
    }
    else {
        alert("Looking for something? Well I am!");
    }
    for(var p in gParams)
    {
        dump(">>>" + p + " " + gParams[p]);
    }
    flock_blogTriggerPublish();
}

function flock_blogPublishClose(success) {
    gParams.success = success;

    if(gParams.categories.length>0 && gB.name=="movabletype") {
        var listener = BlogCategoryListener;
        gB.setPostCategories(listener, gParams.postid, gParams.categories);
    }
    else {
        window.setTimeout("window.close();",0);
    }
}


/************************************************************************/
// XMLHTTP Listeners
/************************************************************************/

/* 
 * Hmm.  May want to add error checking
 */
var BlogCategoryListener = {
    onResult: function(result) {
        window.setTimeout("window.close();",0);
    },

    onFault: function (fault) {
        var msg = flock_blogBundle().GetStringFromName("blog_category_fault");
        alert(msg + "\n\n" + fault.faultString);
        gParams.success = false;
        window.setTimeout("window.close();",0);
    },

    onError: function (errorMsg) {
        var msg = flock_blogBundle().GetStringFromName("blog_category_error");
        alert(msg);
        gParams.success = false;
        window.setTimeout("window.close();",0);
    }
};

function postidHack(blogAccount, oldPost) {
        // quick fix 4 bug #1777
        try {
            var myListener = {
                onError: function (aError) {
                    blogAccount.savePost(oldPost);
                    flock_blogPublishClose(true);
                },
                onFault: function (aFault) {
                    blogAccount.savePost(oldPost);
                    flock_blogPublishClose(true);
                },
                onResult: function (aResult) {
                    oldPost.dateCreated = aResult.dateCreated;// retrieve the proper dateCreated
                    oldPost.permaLink = aResult.permaLink;// update link
                    gParams.permaLink = oldPost.permaLink;
                    oldPost.atomid = aResult.atomid;// update atomid link
                    blogAccount.savePost(oldPost);
                    flock_blogPublishClose(true);
                },
            };
            gB.getPost(myListener, gParams.postid);
        }
        catch(e) {
            alert(e);
            //this is not supported in all blog apis
            flock_blogPublishClose(true);
        }
}

var BlogPublishListener = {
    failCount: 0,
    selectedPost: null,
    onResult: function(result) {
        var blogSettings = flock_blogGetSettings();
        var blogAccount = blogSettings.getAccount(gParams.selectedBlog);

        var uri = this.selectedPost;
        var oldPost = blogAccount.getPostByURI(uri);

        uri.match(/(.+):(.*)/);
        var container = RegExp.$1;
        var postid = RegExp.$2;
        var newPostID;
        if(result.uid) newPostID = result.uid;
        else newPostID = result;

        uri = gParams.selectedBlog + ":posts:" + newPostID;

        blogAccount.deletePost(oldPost);
        if(result.editURI) gParams.editURI = result.editURI;

        gParams.newPostID = uri;
        gParams.postid = newPostID;
        oldPost.uri = uri;
        if(result.atomid) oldPost.atomid = result.atomid;
        if(result.editURI) oldPost.editURI = result.editURI;
        if(result.permaLink) oldPost.permaLink = result.permaLink;
        gParams.permaLink = oldPost.permaLink;
        oldPost.state = FLOCK_BLOG_STATE_OK;

        blogAccount.savePost(oldPost);
        postidHack(blogAccount, oldPost);

    },

    onFault: function (fault) {
        if(this.failCount++<2) {
            flock_blogTriggerPublish();
        }
        else {
            var msg = flock_blogBundle().GetStringFromName("blog_publish_fault");
            alert(msg + "\n\n" + fault.faultString);
            flock_blogPublishClose(false);
        }
    },

    onError: function (errorMsg) {
        var msg = flock_blogBundle().GetStringFromName("blog_publish_error");
        alert(msg);
        flock_blogPublishClose(false);
    }
};

var BlogEditListener = 
{
    failCount: 0,
    selectedPost: null,
    onResult: function(result) {
        if(result) {
            var blogSettings = flock_blogGetSettings();
            var blogAccount = blogSettings.getAccount(gParams.selectedBlog);
            var blogPost = blogAccount.getPostByURI(this.selectedPost);
            blogPost.state = FLOCK_BLOG_STATE_OK;
            blogAccount.savePost(blogPost);
            blogSettings.rebuildAllPosts();
            //window.setTimeout("window.close();",0);
            postidHack(blogAccount, blogPost);
        }
        else {
            flock_blogPublishClose(true);
        }
     },

     onFault: function (fault) {
        if(this.failCount++<2) {
            flock_blogTriggerPublish();
        }
        else {
            var msg = flock_blogBundle().GetStringFromName("blog_publish_fault");
            alert(msg + "\n\n" + fault.faultString);
            flock_blogPublishClose(false);
        }
     },

     onError: function (errorMsg) {
        var msg = flock_blogBundle().GetStringFromName("blog_publish_error");
        alert(msg);
        flock_blogPublishClose(false);
     }
};
