//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

/* 
 * Initialization
 */

var tinyBlog = {};

tinyBlog.WYSIWYG_VIEW = 0;
tinyBlog.SOURCE_VIEW = 1;
tinyBlog.mode = tinyBlog.WYSIWYG_VIEW;
tinyBlog.sourceMimeType = "text/plain";

tinyBlog.setMode = function(aMode) {
    if($("blog-editor-deck").selectedIndex != aMode) {
        this.mode = aMode;
        $("blog-editor-deck").selectedIndex = aMode;
        $("blog-wysiwyg-button").setAttribute("selected", false);
        $("blog-source-button").setAttribute("selected", false);
        if(this.mode==this.WYSIWYG_VIEW) {
            $("blog-wysiwyg-button").setAttribute("selected", true);
            var source = $("blog-editor-source").value;
            tinyBlog.tinyMCE.setContent(source);
        }
        else {
            $("blog-source-button").setAttribute("selected", true);
            $("blog-editor-source").value = tinyBlog.tinyMCE.getRawContent();
        }
    }
}

tinyBlog.toggleMode = function() {
    this.mode = 1 - this.mode;
    tinyBlog.setMode(this.mode);
};

tinyBlog.onload = function() {
    if(!tinyBlog.loaded) {
        tinyBlog.loaded = true;
        $("blog-editor-iframe").setAttribute("src", "chrome://browser/content/flock/blog/tiny_mce.html");
        //$("blog-editor-iframe").setAttribute("src", "chrome://browser/content/flock/blog/tiny_mce.html");
        tinyBlog.setMode(tinyBlog.WYSIWYG_VIEW);
        tinyBlog.wait4TinyMCE2Load();
    }
};

tinyBlog.onunload = function() {
    flock_blogEditorCanClose();
};

tinyBlog.onclose = function() {
    return true;
    flock_blogEditorCanClose();
};

tinyBlog.timerSaveHack = function() {
    try {
        //stupidosity 4 switching default account when no account
        if(tinyBlog.awaitingBlogSetup) {
            var blogSettings = flock_blogGetSettings();
            var accountCount = blogSettings.getAccountCount();
            if(accountCount>1) {
                var defaultAccount = flock_blogGetDefaultAccount();
                flock_blogEditorSelectAccountFromTitle(defaultAccount);
                tinyBlog.awaitingBlogSetup = false;
            }
        }
        tinyBlog.backupContent=tinyBlog.tinyMCE.getRawContent();// = $("blog-editor-source").value;
        if(flock_blogEditorHasChanged()) {
            window.document.commandDispatcher.updateCommands('focus');
        }
        window.setTimeout("tinyBlog.timerSaveHack()", 1200);
    }
    catch(e) { }
};

tinyBlog.getContent = function() {
    if(this.mode==this.WYSIWYG_VIEW) {
        //tinyBlog.backupContent = tinyBlog.tinyMCE.getRawContent();
        return tinyBlog.backupContent;
    }
    else {
        return $("blog-editor-source").value;
    }
};

tinyBlog.saveOverride = function(aEvent) {
    if(aEvent.ctrlKey && aEvent.keyCode==83) {
        aEvent.preventBubble();
        aEvent.preventDefault();
        aEvent.stopPropagation();
        flock_blogEditorSavePostCommand.exec();	    
    }
};

// After the page is completely loaded, we may access elements in the UI
tinyBlog.wait4TinyMCE2Load = function() {
    try {
        var tinyFrame = window.frames[0].window;
        if(tinyFrame.tinyMCE && tinyFrame.tinyMCE.selectedInstance) {
            tinyBlog.tinyMCE = tinyFrame.tinyMCE;
            tinyFrame.frames[0].addEventListener("keydown", tinyBlog.saveOverride, false);
            tinyFrame.frames[0].addEventListener("keypress", tinyBlog.saveOverride, false);
        /*
        tinyFrame.frames[0].addEventListener("keydown", function(aEvent) {
            dump(aEvent.keyCode + "\n");
            aEvent.preventBubble();
            aEvent.preventDefault();
            aEvent.stopPropagation();
        }, false);
        tinyFrame.frames[0].addEventListener("keyup", function(aEvent) {
            dump(aEvent.keyCode + "\n");
            aEvent.preventBubble();
            aEvent.preventDefault();
            aEvent.stopPropagation();
        }, false);
        tinyFrame.frames[0].addEventListener("command", function(aEvent) {
            dump(aEvent.keyCode + "\n");
            aEvent.preventBubble();
            aEvent.preventDefault();
            aEvent.stopPropagation();
        }, false);
        */
            // this is a hack to make sure that we are keeping track of data just
            // in case of a tab close
            // tinyBlog.tinyMCE.onFlockChange = function(aData) {
            // tinyBlog.backupContent = aData;
            // };

            // this fix os to allow immediate dragging/dropping, backspacing, etc.
            function hackEditableFix() {
                try {
                    tinyBlog.tinyMCE.execCommand("Indent");
                    tinyBlog.tinyMCE.execCommand("Outdent");
                } catch(e) {
                    alert(e);
                }
            }

            hackEditableFix();
            tinyBlog.backupContent = tinyBlog.tinyMCE.getRawContent();
            tinyBlog.tinyMCE.selectedInstance.undoLevels = new Array();
            tinyBlog.tinyMCE.selectedInstance.undoIndex = -1;
            tinyBlog.onFinishedLoading();
            window.setTimeout("tinyBlog.timerSaveHack()", 0);
            window.setTimeout('$("blog-main-deck").selectedIndex = 1;',500);
            // Force the tinyMCE to stop loading
            window.setTimeout("window.stop()", 2000);
//@line 169 "/cygdrive/C/tinderbuild/src/flock/mozilla/browser/components/flock/blog/content/tinyBlog.js"
        }
        else {
            window.setTimeout("tinyBlog.wait4TinyMCE2Load()", 100);
        }
    }
    catch(e) {
        window.setTimeout("tinyBlog.wait4TinyMCE2Load()", 100);
    }
};

tinyBlog.onFinishedLoading = function() {
    try {
        flock_blogEditorSetupEditorCommands();
        flock_blogEditorInitUI();
        try { $("flock-blog-title").select(); } catch(e) { }
        flock_blogEditorSetTitle();
        tinyBlog.checkIfWeNeedToOpenTopbar();
        window.document.commandDispatcher.updateCommands('focus');
    }
    catch(e) {
        alert(e + e.fileName + e.lineNumber);
    }
};

tinyBlog.checkIfWeNeedToOpenTopbar = function() {
    var blogSettings = flock_blogGetSettings();
    var accountCount = blogSettings.getAccountCount();
    if(accountCount==1) {
        tinyBlog.awaitingBlogSetup = true;
        var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
        observerService.notifyObservers(null, "flock.topbar.open", "flock_BlogTopbarBroadcaster");
    }
};

tinyBlog.keys = {};

tinyBlog.keys.onTitleKeypress = function(aEvent) {
    switch(aEvent.keyCode) {
        case aEvent.DOM_VK_TAB:
            window.frames[0].frames[0].focus();
            aEvent.preventDefault();
        break;
    }
};

////////////////old code

var gBlogContent = null;
var gSelectedBlogAccountAPI = null;
var gBlogTitle = null;
var gSelectedPost = null;
var gSelectedBlog = null;
var gBlogEditCommandController = null;

var gBlogPost = null;

function flock_blogEditorSetTitle() {
    var title = "Blog Post:" + " " + $("flock-blog-title").value;
    window.title = title;
    window.document.title = title;
}

function flock_blogEditorInitUI() {
    var blogSettings = flock_blogGetSettings();

//    $("flock-blog-notify-services").checked = flock_getBoolPref("flock.blog.notify");
    var qs = new flock_PageQuery(window.location.search);

    gSelectedPost = hexDecode(qs.getValue("postid"));
    gSelectedPost.match(/(.+):posts:(.*)/);
    gSelectedBlog = RegExp.$1;

    var postid = RegExp.$2;
    var origShit = gSelectedPost;

    flock_blogEditorEditPost(gSelectedPost);

    //THis is a little hack to allow drafts to not show up in folder till saved
    if(gSelectedPost == FLOCK_BLOG_RDF_TMP_POST) {
        var tmpDate = gBlogPost.dateCreated.getTime();
        gSelectedPost = FLOCK_BLOG_DRAFTS_FOLDER + ":posts:" + tmpDate;
    }

    gBlogPost.uri = gSelectedPost;
    gSelectedPost.match(/(.+):posts:*/);

    gSelectedBlog = RegExp.$1;

    var ds = blogSettings.ds;
    var accts = $("flock-blog-accounts");
    accts.database.AddDataSource(ds.getRawDataSource());
    accts.builder.rebuild();

    
    var selectedValue = null;
    selectedValue = blogSettings.getAccountTitle(gSelectedBlog);
    if(origShit == FLOCK_BLOG_RDF_TMP_POST) selectedValue = flock_blogGetDefaultAccount();
    accts.value = selectedValue;
    if(!accts.selectedItem) accts.selectedIndex = 0;

    flock_blogEditorSelectAccount(accts.selectedItem.label);

    if(gBlogPost.getState() != FLOCK_BLOG_STATE_OK) $("blog-publish").value = "draft";
    else $("blog-publish").value = "publish";
}

function flock_setCategoryEnabledness() {
    if(flock_blogEditorRefreshCategoriesCommand.isEnabled()) {
        flock_blogEditorSetupCategories();
        $("flock-blog-categories-container").removeAttribute("collapsed");
        flock_blogEditorRefreshCategoriesCommand.exec();
    }
    else {
        $("flock-blog-categories-container").setAttribute("collapsed", true);
    }
}

function flock_blogEditorSelectAccountFromTitle(aTitle) {
    var blogSettings = flock_blogGetSettings();
    var accts = $("flock-blog-accounts");
    accts.value = aTitle;
    flock_blogEditorSelectAccount(accts.selectedItem.label);
}

function flock_blogEditorSelectAccount(blog) {
    gSelectedBlog = FLOCK_BLOG_RDF_SETTINGS + ":" + blog;
    var blogSettings = flock_blogGetSettings();
    var accts = $("flock-blog-accounts");
//    flock_blogSetDefaultAccountIndex(accts.selectedIndex);
    if(accts.value!=FLOCK_BLOG_DRAFTS_NAME) flock_blogSetDefaultAccount(accts.value);
    gSelectedBlogAccountAPI = blogSettings.getAccount(gSelectedBlog).getBlogAPI();
    flock_setCategoryEnabledness();
}

/////////////////////////////////////////////////////////////////
// Categories
/////////////////////////////////////////////////////////////////

function flock_blogEditorSetupCategories() {
    var blogSettings = flock_blogGetSettings();
    var blogAccount = blogSettings.getAccount(gSelectedBlog);
    var ds = blogSettings.ds;
    $("flock-blog-categories").database.RemoveDataSource(ds.getRawDataSource());
    $("flock-blog-categories").database.AddDataSource(ds.getRawDataSource());
    $("flock-blog-categories").ref = blogAccount.getCategoriesRef();
    $("flock-blog-categories").builder.rebuild();
}

/*
* Notes: the array categories is an array of structs containing
  String categoryId and boolean isPrimary.
  Using isPrimary to set the primary category is optional
  --in the absence of this flag,
  the first struct in the array will be assigned the primary category
  for the post.
*/
function flock_blogEditorGetCategoryIdArray() {
    var rval = new Array();
    var categories = $("flock-blog-categories").childNodes;
    for(var i=0;i<categories.length;++i) {
        var category = categories.item(i);
        if(!category.selected) continue;
        var categoryId = category.firstChild.getAttribute("categoryId");
        var obj = {
            categoryId: categoryId,   
        };
        rval.push(obj);
    }
    return rval;
}


/////////////////////////////////////////////////////////////////
// Saving
/////////////////////////////////////////////////////////////////

function flock_blogEditorCanClose() {

    var result;
    var strbundle=document.getElementById("strings");
    var saveentry=strbundle.getString("blog_saveEntry");
    var doyouwanttosave=strbundle.getString("blog_doYouWantToSave");

    if(flock_blogEditorHasChanged()) {
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var flags=promptService.BUTTON_TITLE_SAVE * promptService.BUTTON_POS_0 +
//	    promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1 +
	    promptService.BUTTON_TITLE_DONT_SAVE * promptService.BUTTON_POS_1;
	
	result = promptService.confirmEx(window, saveentry, doyouwanttosave, flags,
					 null, null, null, null, {});
	
	switch (result) {
        case 0: // Save
            flock_blogEditorSavePostCommand.exec();	    
        case 1: // Don't save
        }
    } 
    window.controllers.removeController(gBlogEditCommandController);
}

function flock_blogEditorHasChanged() {
    var myData = {};
    flock_blogEditorUpdateGlobalPost(myData);
    if(!gBlogPost) return false;
    var a = myData.content.replace(/\r/g,"");
    var b = gBlogPost.content.replace(/\r/g,"");
    //jhdump("<" + a + ">\n<" + b + ">\n");
    //dump("<" + a.length + "><" + b.length + ">\n");
    if(a!=b) {
        return true;
    }
    if(myData.tags!=gBlogPost.tags) return true;
    if(myData.title!=gBlogPost.title) return true;
    return false;
}

function flock_blogEditorUpdateGlobalPost(aData) {

    var data = gBlogPost;
    if(aData) data = aData;

    data.postid = gSelectedPost;
    data.title =  $("flock-blog-title").value;
    try {
        data.content = tinyBlog.getContent();
    }
    catch(e) {
        data.content = tinyBlog.getContent();
    }
    data.tags = $("flock-blog-tags").value;

    return data;
}

// Publisihing and Editing
/////////////////////////////////////////////////////////////////

function flock_blogEditorAddTags(html) {
    var tags = gBlogPost.tags;

    if(!tags || tags.length==0) return html;
    var tags_ar = tags.split(",");

    var tag_html = "";
    tag_html += '<!-- technorati tags begin -->';
    tag_html += '<p style="font-size:10px;text-align:right;">technorati tags: ';


    for(var i=0;i<tags_ar.length;++i) {
        tag_html += '<a href="http://technorati.com/tag/';
        tag_html += tags_ar[i];
        tag_html += '" rel="tag">';
        tag_html += tags_ar[i];
        tag_html += '</a>';
        if(i!=tags_ar.length-1) {
            tag_html += ", ";
        }
    }

    tag_html += '</p>';
    tag_html +="<!-- technorati tags end -->";
    html += tag_html;
    return html;
}

function flock_blogEditorPublishPost(aPublish) {
    $("flock-do-post").setAttribute("disabled", true);
    try {
        flock_blogEditorSavePostCommand.exec();

        if(gSelectedBlog==FLOCK_BLOG_DRAFTS_FOLDER) {
            return;
        }

        var html = tinyBlog.getContent();

        html = flock_blogEditorAddTags(html);

        var title = document.getElementById("flock-blog-title").value;

        gSelectedPost.match(/.+:(.*)/);
        var postid = RegExp.$1;
        var state = gBlogPost.getState();

        var date = gBlogPost.dateCreated;
        var newPost = false;

        if(state==FLOCK_BLOG_STATE_NEW) {
            newPost = true;
        }

        var categories = flock_blogEditorGetCategoryIdArray();

        var params = {
            newPost : newPost,
            title : title,
            date : date,
            html : html,
            publish : aPublish,
            selectedBlog : gSelectedBlog,
            selectedPost : gSelectedPost,
            postid : postid,
            newPostID : null,
            editURI : gBlogPost.editURI,
            atomid : gBlogPost.atomid,
            categories : categories,
            success : false,
            permaLink : gBlogPost.permaLink,
        };

        window.openDialog("blogPublish.xul", "PublishPost", "modal,centerscreen", params);
        if(params.success) {
            if(aPublish) {
                var blogSettings = flock_blogGetSettings();
                var blogAccount = blogSettings.getAccount(gSelectedBlog);
                var url = blogAccount.url;
                if(params.permaLink) {
                    url = params.permaLink;
                }
                flock.browser.open(url, "foreground_tab");
                window.close();
                return;
            }
            if(newPost) {
                var blogSettings = flock_blogGetSettings();
                var blogAccount = blogSettings.getAccount(gSelectedBlog);
                gSelectedPost = params.newPostID;
                gBlogPost = blogAccount.getPostByURI(gSelectedPost);
            }
            gBlogPost.setState(FLOCK_BLOG_STATE_DRAFT);
        }

    } 
    catch(e) {
        alert(e + " " + e.lineNumber + " " + e.fileName);
    }
    $("flock-do-post").removeAttribute("disabled");
}

function flock_blogEditorEditPost(posturi) {
    gSelectedPost = posturi;
    var blogSettings = flock_blogGetSettings();
    var account = blogSettings.getAccount(gSelectedBlog);
    gBlogPost = account.getPostByURI(gSelectedPost);


    var content = gBlogPost.content;

    tinyBlog.tinyMCE.setContent(content);
    gBlogPost.content = tinyBlog.backupContent = tinyBlog.tinyMCE.getContent();

    var title = gBlogPost.title;

    $("flock-blog-title").value = title;
    //$("flock-blog-tags").loadString(gBlogPost.tags);
    $("flock-blog-tags").value = gBlogPost.tags;

   // var html = flock_blogEditorGetBody();
    flock_blogEditorUpdateGlobalPost();
}

/////////////////////////////////////////////////////////////////
// Commands
/////////////////////////////////////////////////////////////////
/*
*/

var flock_blogEditorSavePostCommand = {
    isEnabled: function() {
        return gSelectedPost != null &&  flock_blogEditorHasChanged();
    },
    exec: function() {
        try {
            flock_blogEditorUpdateGlobalPost();
            var blogSettings = flock_blogGetSettings();
            var account = blogSettings.getAccount(gSelectedBlog);
            gBlogPost.uri = gSelectedPost;
            if(gBlogPost.state!=FLOCK_BLOG_STATE_NEW) {
                gBlogPost.state = FLOCK_BLOG_STATE_DRAFT;
            }
            account.savePost(gBlogPost);
//            $("flock-blog-tags").commitFormHistory();
            flock_blogEditorSetTitle();
            window.document.commandDispatcher.updateCommands('focus');
        }
        catch(e) {
            flock_error(e);
        }
    },
}

var flock_blogEditorPublishPostCommand = {
    isEnabled: function() {
        if(!gSelectedBlog) return false;
        if(gSelectedBlog.match(FLOCK_BLOG_DRAFTS_FOLDER)) return false;
        return gSelectedPost != null;
    },
    exec: function() {
        var publish = true;
        if($("blog-publish").value != "publish") publish = false;
        //flock_blogEditorPublishPost(publish);
        // UI adjustement to simplify UI - there is no ability to provide
        // online drafts
        flock_blogEditorPublishPost(true);
    },
}

var flock_blogEditorSelectAccountCommand = {
    isEnabled: function() {
        if(!gBlogPost) return false;
        var state = gBlogPost.getState();
        if(state==FLOCK_BLOG_STATE_NEW) {
            return true;
        }
        return false;
    },
    exec: function() {
    },
}

var flock_blogEditorRefreshCategoriesCommand = {

    // Implement Command Functor
    isEnabled: function() {
        if(!gSelectedBlog) return false;
        if(!gSelectedBlogAccountAPI) return false;
        if(!gSelectedBlogAccountAPI.supportsCategories) return false;
        if(gSelectedBlog.match(FLOCK_BLOG_DRAFTS_FOLDER)) return false;
        return !this.inProgress;
    },

    exec: function() {
        var blogSettings = flock_blogGetSettings();
        var blogAccount = blogSettings.getAccount(gSelectedBlog);
        var B = blogAccount.getBlogAPI();
        blogAccount.flushCategories();
        this.inProgress = true;
        B.getCategoryList(this);
    },

    // Implement refresh listener
    onFault: function (aFault) {
        this.inProgress = false;
    },
    onResult: function (aResult) {
        if(aResult) {
            for (var i=0;i<aResult.length;++i) {
                var blogSettings = flock_blogGetSettings();
                var blogAccount = blogSettings.getAccount(gSelectedBlog);
                var categoryName = aResult[i].categoryName;
                var categoryId = aResult[i].categoryId;
                blogAccount.addCategory(categoryId, categoryName);
            }
        }
        this.inProgress = false;
    },
    onError: function (aFault) {
        this.inProgress = false;
    },
    inProgress: false,
}

function flock_blogEditorSetupEditorCommands() {
    if(gBlogEditCommandController) return;
    gBlogEditCommandController = new CommandController();

    gBlogEditCommandController.cmd_flock_blogPublishPost = flock_blogEditorPublishPostCommand;
    gBlogEditCommandController.cmd_flock_blogSavePost = flock_blogEditorSavePostCommand;
    gBlogEditCommandController.cmd_flock_blogSelectAccount = flock_blogEditorSelectAccountCommand;
    gBlogEditCommandController.cmd_flock_blogRefreshCategories = flock_blogEditorRefreshCategoriesCommand;

    window.controllers.appendController(gBlogEditCommandController);
    window.addEventListener('focus',function () { window.document.commandDispatcher.updateCommands('focus'); },false);
    window.addEventListener('click',function () { window.document.commandDispatcher.updateCommands('click'); },false);
    window.addEventListener('dragdrop',function () { alert("drop"); },false);
    window.document.commandDispatcher.updateCommands('focus');
    window.focus();
}

function flock_blogUpdateEditCommands() {
    flock_blogUpdateCommands($("flock_BlogEditCommands"), gBlogCommandController);
}

/////////////////////////////////////////////////////////////////
// Keybindings
/////////////////////////////////////////////////////////////////


