// vim: foldmethod=marker

flock.xpcom = {/*{{{*/
    // am i smart enough
    // cute enough
    // rich enough
    // tough enough?
}/*}}}*/

flock.xpcom.getService = function (aClass, aInterface) {/*{{{*/
    if (typeof aInterface == "string") {
        aInterface = Components.interfaces[aInterface];
    }
    return Components.classes[aClass].getService(aInterface);
}/*}}}*/
flock.xpcom.createInstance = function (aClass, aInterface) {/*{{{*/
    if (typeof aInterface == "string") {
        aInterface = Components.interfaces[aInterface];
    }
    return Components.classes[aClass].createInstance(aInterface);
}/*}}}*/

flock.xpcom.__defineGetter__('windowMediator', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/appshell/window-mediator;1",
        "nsIWindowMediator"
    );
});/*}}}*/
flock.xpcom.__defineGetter__('xulSortService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/xul/xul-sort-service;1",
        "nsIXULSortService"
    );
});/*}}}*/
flock.xpcom.__defineGetter__('observerService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/observer-service;1",
        "nsIObserverService"
    );   
});/*}}}*/
flock.xpcom.__defineGetter__('accessibilityService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/accessibilityService;1",
        "nsIAccessibilityService"
    );   
});/*}}}*/
flock.xpcom.__defineGetter__('formHistoryService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/satchel/form-history;1",
        "nsIFormHistory"
    );   
});/*}}}*/


// observer stuff
flock.xpcom.addObserver = function (aTopic, aObserver, aWeakRef) {/*{{{*/
    if (typeof aObserver == "function") {
        var observer = { observe: aObserver };
    }
    else {
        var observer = aObserver;
    }
    var weakref = aWeakRef || false;
    flock.xpcom.observerService.addObserver(observer, aTopic, weakref);
    return observer;
};/*}}}*/
flock.xpcom.notifyObservers = function (aTopic, aSubject, aData) {/*{{{*/
    var subject = aSubject;
    if (typeof subject == "string") {
        subject = new flock.xpcom.supportsString(aSubject);
    }
    flock.xpcom.observerService.notifyObservers(subject, aTopic, aData);
};/*}}}*/
flock.xpcom.pingObservers = function (aSubject) {/*{{{*/
    flock.xpcom.observerService.notifyObservers(
        new flock.xpcom.supportsString(),
        aSubject,
        null
    );
};/*}}}*/
flock.xpcom.removeObserver = function (aTopic, aObserver) {/*{{{*/
    flock.xpcom.observerService.removeObserver(aObserver, aTopic);
};/*}}}*/

// accessibility stuff
flock.xpcom.createAccessible = function (aType) {/*{{{*/
    var args = flock.lang.toArray(arguments);
    args.shift();
    return flock.xpcom.accessibilityService['create'+aType+'Accessible']
        .apply(this, args);
};/*}}}*/



// Fakes the nsISimpleEnumerator to pass Javascript through it
flock.xpcom.JsSimpleEnumerator = function (aArr, aOpts) {/*{{{*/
    flock.Base.call(this, aOpts);
    this.data = aArr;
}/*}}}*/
dojo.inherits(flock.xpcom.JsSimpleEnumerator, flock.Base);
dojo.lang.extend(flock.xpcom.JsSimpleEnumerator, {
    _idx: 0,
    hasMoreElements: function () {/*{{{*/
        return (this.data.length > this._idx);
    },/*}}}*/
    getNext: function () {/*{{{*/
        var item = this.data[this._idx];
        this._idx++;
        // make it look like an nsISupports
        return {
            QueryInterface: function () { 
                return this.data;    
            },   
            data: item,
        };
    }/*}}}*/
});




flock.xpcom.supportsString = function (aStr, aOpts) {
    this._proxy = flock.xpcom.createInstance(
        '@mozilla.org/supports-string;1',
        'nsISupportsString'
    );
    this._proxy.data = aStr;
    flock.Base.call(this, aOpts);
};
dojo.inherits(flock.xpcom.supportsString, flock.Base);
dojo.lang.extend(flock.xpcom.supportsString, {
    _proxy: null,
    get data() { return this._proxy.data; },
    set data(aVal) { return this._proxy.data = aVal; },
    get type() { return this._proxy.type; },
    toString: function () { return this._proxy.toString() },
    QueryInterface: function () { return this._proxy.QueryInterface.apply(this._proxy, arguments); },
});
