/*  *

 * ***** BEGIN LICENSE BLOCK *****

 * Version: MPL 1.1

 *

 * The contents of this file are subject to the Mozilla Public License Version

 * 1.1 (the "License"); you may not use this file except in compliance with

 * the License. You may obtain a copy of the License at

 * http://www.mozilla.org/MPL/

 *

 * Software distributed under the License is distributed on an "AS IS" basis,

 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License

 * for the specific language governing rights and limitations under the

 * License.

 *

 * The Original Code Shadows.com API client implementation.

 *

 * The Initial Developer of the Original Code is

 * Pluck Corporation. This code is Copyright (C) 2005, 2006

 * All Rights Reserved.

 *

 * Contributor(s):

 *   Carl Brown (carlb@shadows.com)

 *   Duane Fields (dfields@pluck.com)

 *

 * ***** END LICENSE BLOCK ***** */



shadows.setBookmarks = function (aUsername, aPassword, aBookmarkArray, fnCallBack) {



    dump('setBookmarks: called with \n');

    dump('setBookmarks: aUsername "' + aUsername + '"\n');

    dump('setBookmarks: aPassword "' + aPassword + '"\n');

    this.msetBookmarksRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("bookmarks"));

    

    dump('setBookmarks: XMLRPCUrl "' + shadows.XmlRpc.Url("bookmarks") + '"\n');



    var args = [{UserName: aUsername, Password: aPassword}];

    args.push(aBookmarkArray);

        

    dump('setBookmarks: args "' + args + '"\n');



    var listener = new Object ();

    listener.onResult = function (aResult) {

        dump('setBookmarks: result \n');

        dd (aResult);

        dump('setBookmarks: returning "' + aResult + '"\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(aResult);

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {

            fnCallBack.onResult(aResult);

        }

    }

    listener.onFault = function (aFaultCode, aFaultString) {

        PluckDebug.fail('setBookmarks: fault code=' + aFaultCode + '\n');

        PluckDebug.fail('                     string="' +  aFaultString + '\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {

            fnCallBack.onFault(aFaultCode, aFaultString);

        }

    }

    listener.onError = function (aMessage) {

        PluckDebug.fail('setBookmarks: error "'+aMessage+'"\n');

        this.result=false;

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'error "'+aMessage+'"\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {

            fnCallBack.onError(aMessage);

        }

    }

    this.msetBookmarksRPC.call ('shadows.bookmark.auth.set', args, listener);

    return true;

}



shadows.getBookmarks = function (aUsername, aPassword, aURLArray, fnCallBack) {



    dump('getBookmarks: called with \n');

    dump('getBookmarks: aUsername "' + aUsername + '"\n');

    dump('getBookmarks: aPassword "' + aPassword + '"\n');

    dump('getBookmarks: aURL Array "' + aURLArray + '"\n');

    this.mgetBookmarksRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("bookmarks"));

    

    dump('getBookmarks: XMLRPCUrl "' + shadows.XmlRpc.Url("bookmarks") + '"\n');



    var args = [{UserName: aUsername, Password: aPassword}];

    args.push(aURLArray);

        

    dump('getBookmarks: args "' + args + '"\n');



        var listener = new Object ();

    listener.onResult = function (aResult) {

        dump('getBookmarks: result \n');

        dump('getBookmarks: returning "' + aResult + '"\n');

        dump('getBookmarks: returning "' + aResult['Response'] + '"\n');

        dump('getBookmarks: returning "' + aResult['Response']['OverallStatus'] + '"\n');

        dump('getBookmarks: returning "' + aResult['Response']['OverallStatus']['Entry'] + '"\n');

        dump('getBookmarks: returning "' + aResult['Response']['OverallStatus']['Entry']['Status'] + '"\n');

        dd (aResult);

        if(typeof fnCallBack=="function") {

            fnCallBack(aResult);

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {

            fnCallBack.onResult(aResult);

        }

    }

    listener.onFault = function (aFaultCode, aFaultString) {

        PluckDebug.fail('getBookmarks: fault code=' + aFaultCode + '\n');

        PluckDebug.fail('                     string="' +  aFaultString + '\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {

            fnCallBack.onFault(aFaultCode, aFaultString);

        }



    }

    listener.onError = function (aMessage) {

        PluckDebug.fail('getBookmarks: error "'+aMessage+'"\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'error "'+aMessage+'"\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {

            fnCallBack.onError(aMessage);

        }

    }

    this.mgetBookmarksRPC.call ('shadows.bookmark.auth.get', args, listener);



    return true;

}



shadows.getAllBookmarks = function (aUsername, aPassword, version, fnCallBack) {



    dump('getAllBookmarks: called with \n');

    dump('getAllBookmarks: aUsername "' + aUsername + '"\n');

    dump('getAllBookmarks: aPassword "' + aPassword + '"\n');

    this.mgetAllBookmarksRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("bookmarks"));

    

    dump('getAllBookmarks: XMLRPCUrl "' + shadows.XmlRpc.Url("bookmarks") + '"\n');



    var args = [{UserName: aUsername, Password: aPassword}];



    args.push(version);

            

    dump('getAllBookmarks: args "' + args + '"\n');



        var listener = new Object ();

    listener.onResult = function (aResult) {

        dump('getAllBookmarks: result \n');

        dd (aResult);

        dump('getAllBookmarks: returning "' + aResult + '"\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(aResult);

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {

            fnCallBack.onResult(aResult);

        }

    }

    listener.onFault = function (aFaultCode, aFaultString) {

        PluckDebug.fail('getAllBookmarks: fault code=' + aFaultCode + '\n');

        PluckDebug.fail('                     string="' +  aFaultString + '\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {

            fnCallBack.onFault(aFaultCode, aFaultString);

        }

    }

    listener.onError = function (aMessage) {

        PluckDebug.fail('getAllBookmarks: error "'+aMessage+'"\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'error "'+aMessage+'"\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {

            fnCallBack.onError(aMessage);

        }

    }



    this.mgetAllBookmarksRPC.call ('shadows.bookmark.auth.getall', args, listener);



    return true;

}



shadows.RemoveBookmarks = function (aUsername, aPassword, aURLArray, fnCallBack) {



    dump('RemoveBookmarks: called with \n');

    dump('RemoveBookmarks: aUsername "' + aUsername + '"\n');

    dump('RemoveBookmarks: aPassword "' + aPassword + '"\n');

    dump('RemoveBookmarks: aURL Array "' + aURLArray + '"\n');

    this.mRemoveBookmarksRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("bookmarks"));

    

    dump('RemoveBookmarks: XMLRPCUrl "' + shadows.XmlRpc.Url("bookmarks") + '"\n');



    var args = [{UserName: aUsername, Password: aPassword}];

    args.push(aURLArray);

        

    dump('RemoveBookmarks: args "' + args + '"\n');



        var listener = new Object ();

    listener.onResult = function (aResult) {

        dump('RemoveBookmarks: result \n');

        dd (aResult);

        dump('RemoveBookmarks: returning "' + aResult + '"\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(aResult);

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {

            fnCallBack.onResult(aResult);

        }

    }

    listener.onFault = function (aFaultCode, aFaultString) {

        PluckDebug.fail('RemoveBookmarks: fault code=' + aFaultCode + '\n');

        PluckDebug.fail('                     string="' +  aFaultString + '\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {

            fnCallBack.onFault(aFaultCode, aFaultString);

        }

    }

    listener.onError = function (aMessage) {

        PluckDebug.fail('RemoveBookmarks: error "'+aMessage+'"\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'error "'+aMessage+'"\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {

            fnCallBack.onError(aMessage);

        }

    }

    this.mRemoveBookmarksRPC.call ('shadows.bookmark.auth.remove', args, listener);



    return true;

}



shadows.GetBookmarkVersion = function (aUsername, aPassword, fnCallBack) {



    dump('GetBookmarkVersion: called with \n');

    dump('GetBookmarkVersion: aUsername "' + aUsername + '"\n');

    dump('GetBookmarkVersion: aPassword "' + aPassword + '"\n');

    this.mGetBookmarkVersionRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("bookmarks"));

    

    dump('GetBookmarkVersion: XMLRPCUrl "' + shadows.XmlRpc.Url("bookmarks") + '"\n');



    var args = [{UserName: aUsername, Password: aPassword}];

        

    dump('GetBookmarkVersion: args "' + args + '"\n');



        var listener = new Object ();

    listener.onResult = function (aResult) {

        dump('GetBookmarkVersion: result \n');

        dd (aResult);

        dump('GetBookmarkVersion: returning "' + aResult + '"\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(aResult);

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {

            fnCallBack.onResult(aResult);

        }

    }

    listener.onFault = function (aFaultCode, aFaultString) {

        PluckDebug.fail('GetBookmarkVersion: fault code=' + aFaultCode + '\n');

        PluckDebug.fail('                     string="' +  aFaultString + '\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {

            fnCallBack.onFault(aFaultCode, aFaultString);

        }

    }

    listener.onError = function (aMessage) {

        PluckDebug.fail('GetBookmarkVersion: error "'+aMessage+'"\n');

        if(typeof fnCallBack=="function") {

            fnCallBack(false, 'error "'+aMessage+'"\n');

        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {

            fnCallBack.onError(aMessage);

        }

    }

    this.mGetBookmarkVersionRPC.call ('shadows.bookmark.auth.getversion', args, listener);



    return true;

}

