//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

const TECHNORAT_APIKEY = "3f7bc5985eaec27496df7b8b0ef88425";
const LIMIT = 50;

gQueryUrl = "";
gQueryTitle = "";

/*
 * User Interface
 */

function goToUrl(event, anUrl){
   if (anUrl != '') {
      if ((event.ctrlKey) || (event.button == 1) || (event.metaKey)){
         var tbrowser = top.document.getElementById("content");
         tbrowser.addTab(anUrl);
      } else {
         top.content.document.location = anUrl;
      }
   }
}

function technoratiShow(aListItem){
    var valueArray = aListItem.getAttribute("value").split("||");
    
    var title = $("flock-technorati-topbar-title");
    var date = $("flock-technorati-topbar-date");
    var excerpt = $("flock-technorati-topbar-excerpt");

    title.value = aListItem.getAttribute("label");
    date.value = valueArray[1];
    excerpt.replaceChild(document.createTextNode(valueArray[2]), excerpt.firstChild);
}

function technoratiNoResult(){
    var title = $("flock-technorati-topbar-title");
    var date = $("flock-technorati-topbar-date");
    var excerpt = $("flock-technorati-topbar-excerpt");
    var strBundle = document.getElementById("strBundle");
    
    title.value = strBundle.getString("flock.conversations.noresult.title"); 
    date.value = "";
    excerpt.replaceChild(
       document.createTextNode(strBundle.getString("flock.conversations.noresult.msg")),
       excerpt.firstChild);
}
    
function technoratiClick(aEvent, aListItem){
    var url = aListItem.getAttribute("value").split("||")[0];

    if ((aEvent.ctrlKey) || (aEvent.button == 1) || (aEvent.metaKey)){
	var tbrowser = top.document.getElementById("content");
	tbrowser.addTab(url);
    } else {
	top.content.document.location = url;
    }
}

function technoratiClean() {
    var technoratibox = $("flock-technorati-topbar-entries");
    var technotitle = $("flock-technorati-topbar-title");
    var technodate = $("flock-technorati-topbar-date");
    var technoexcerpt = $("flock-technorati-topbar-excerpt");
    var strBundle = document.getElementById("strBundle");

    // Clear the list & the description
    var items = technoratibox.getElementsByTagName('listitem');
    while(items.length > 0) {
	    technoratibox.removeChild(items[0]);
    }
    technotitle.value = strBundle.getString("flock.conversations.loading");
    technodate.value = "";
    technoexcerpt.replaceChild(document.createTextNode(strBundle.getString("flock.conversations.retrievingInfo")), technoexcerpt.firstChild);
}

function technoratiReload() {
    technoratiGetRelated(window.top.content.document.location.toString(),
                         $$("content").mCurrentBrowser.contentWindow.document.title + "");
}

function technoratiAddComment() {
        var postid = FLOCK_BLOG_RDF_TMP_POST;
        var url = flock_blogBuildBlogThisPostURI(postid);

        if (gQueryUrl != "") {
            var blogPost = new BlogPost();
            blogPost.title = gQueryTitle;
            blogPost.uri = postid;
            blogPost.content = "<p><a href='"+gQueryUrl+"'>"+gQueryTitle+"</a></p>";
            XXX('Blog post content: ', blogPost.content);
            blogPost.state = FLOCK_BLOG_STATE_NEW;
            blogPost.dateCreated = new Date();
            var helperAccount = new BlogAccount();
            helperAccount.savePost(blogPost);
            flock_blogDoOpenPost(url);
        }
        return;
}


/*
 * Access Technorati
 */

function cosmosRequest(aURL) {
    return "http://api.technorati.com/cosmos?key="+TECHNORAT_APIKEY+"&limit="+LIMIT+"&url="+aURL;
}

function technoratiGetRelated(aURL, aTitle) {
    if(aURL.match("http://")){
        var req = new Ajax();

        technoratiClean();
        gQueryUrl = aURL;
        gQueryTitle = aTitle;
        $('query-url-desc').label= aURL;
        req.onSuccess = technoratiGetRelatedResponse;
        req.request(cosmosRequest(aURL));
    }
}

function technoratiPermalink(anItem) {
  var permalink = anItem.getElementsByTagName("nearestpermalink")[0].textContent;
  if (permalink == ""){
    var weblog = anItem.getElementsByTagName("weblog")[0];
    permalink = weblog.getElementsByTagName("url")[0].textContent;
  }

  return permalink;
}

function technoratiGetRelatedResponse(aRes) {
    var technoratibox = $("flock-technorati-topbar-entries");
    var technotitle = $("flock-technorati-topbar-title");
    var technodate = $("flock-technorati-topbar-date");
    var technoexcerpt = $("flock-technorati-topbar-excerpt");

    XXX('*CONV* Technorati response ', aRes);

    var rTapi = aRes.responseXML.getElementsByTagName("tapi")[0];
    var rDoc = rTapi.getElementsByTagName("document")[0];
    var rItemList = rDoc.getElementsByTagName("item");

    var rResult = new Array();
    // Check for duplicates
    for (i = 0; i < rItemList.length; i++) {
      var isDup = false;
      var item = rItemList[i];
      var permalink = technoratiPermalink(item);

      for (j = 0; j < rResult.length; j++) {
      	if (permalink == technoratiPermalink(rResult[j])) {
      	  isDup = true;
      	}
      }
      if (isDup == false) {
	    rResult[rResult.length] = item;
      }
    }
    for (i = 0; i < rResult.length; i++) {
      var item = rResult[i];
      var weblog = item.getElementsByTagName("weblog")[0];
      var name = weblog.getElementsByTagName("name")[0].textContent;
      var permalink = technoratiPermalink(item);
      var excerpt = item.getElementsByTagName("excerpt")[0].textContent;
      var lastupdate = item.getElementsByTagName("lastupdate")[0].textContent;
      var value = permalink+"||"+lastupdate+"||"+excerpt;
      var newItem = technoratibox.appendItem(name, value);
      newItem.setAttribute("class", "flockBlogPostItem");
      newItem.setAttribute("onmouseover","technoratiShow(this);");
    }
    if (rResult.length == 0) {
        technoratiNoResult();
    } else {
        technoratiShow(technoratibox.getItemAtIndex(0));
    }
}

function technoratiInit() {
    XXX("technoratiInit()");

    technoratiReload();
}

// Drag'n drop

var flock_technoratiTopbarDDObserver =
{
    onDragOver: function(aEvent,aFlavor,aSession) {
    },

    onDrop: function(aEvent,aDropData,aSession) {
      XXX('Drop on technorati well...');
      if(aDropData.flavour.contentType=='text/x-moz-url'){
	    var node=aSession.sourceNode;
	    technoratiGetRelated(window.top.content.document.location.toString(), 
	                         window.top.content.document.location.toString());
      }
    },

    onDragStart: function(aEvent, aTransferData, aAction) {
    },

    getSupportedFlavours: function() {
      var flavors = new FlavourSet();
      flavors.appendFlavour('text/x-moz-url');
      return flavors;
    }
}
