// vim: ts=4 sw=4 expandtab cindent foldmethod=marker
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gOrigPillHeight = 0;
var gOrigWindowHeight = 0;
var gOrigWindowWidth = 0;

const FIELD_NAME = Components.interfaces.flockIFavoriteProperties.FIELD_NAME;
const FIELD_DESCRIPTION = Components.interfaces.flockIFavoriteProperties.FIELD_DESCRIPTION;
const FIELD_TAGS = Components.interfaces.flockIFavoriteProperties.FIELD_TAGS;

function flock_fixTags() {
    window.setTimeout("flock_fixTags()", 500);
    var w = gOrigWindowWidth;
    var h = gOrigWindowHeight + gOrigPillHeight + ($("tags").boxObject.height-gOrigPillHeight);
    window.resizeTo(w,h);
}

function flock_initFixTags() {
    gOrigPillHeight = $('tags').boxObject.height;
    gOrigWindowHeight = $('flock_favoriteProperties').boxObject.height;
    gOrigWindowWidth = $('flock_favoriteProperties').boxObject.width;
    window.setTimeout("flock_fixTags();",0);
}

function flock_init() {/*{{{*/
    window.setTimeout("flock_initFixTags();",0);

    var flockFavorites = flock_getFavoritesService();
    properties = flockFavorites.getFavoriteProperties (window.arguments[0]);

    // set url
    $('url').value = window.arguments[0];

    // set name
    var nameNode = $('name');
    var name = '';
    if (properties.fields & FIELD_NAME) {
        nameNode.value = name;
        document.title = document.title.replace(/\*\*favorite_title\*\*/gi, 
                name);
    }

    // set description
    if (properties.fields & FIELD_DESCRIPTION) { 
        $('description').value = properties.description;
    }

    // set tags
    if (properties.fields & FIELD_TAGS) {
        $('tags').loadString(properties.tags);
    }

    // set initial focus
    nameNode.focus();
    nameNode.select();
}/*}}}*/

function flock_commit() {/*{{{*/
    var flockFavorites = flock_getFavoritesService();

    flockFavorites.updateFavorite(
        window.arguments[0], 
        {   name: $('name').value, 
            tags: $('tags').toString(),
            description: $('description').value,
            fields: FIELD_NAME|FIELD_TAGS|FIELD_DESCRIPTION
        }
    );

    window.close();
    return true;
}/*}}}*/
