// vim: ts=4 sw=4 cindent expandtab foldmethod=marker
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var rv = {};

function wizardOnLoad () {
    if (window.arguments) {
        
        // Assuming if the caller cares enough to know if wizard was successful, 
        // it isn't the first run (so the text just says what sharing is - no greatings)- JA
        
        rv = window.arguments[0];
        $('favoritesFirstRunWizard').goTo('revisit');
    }
}

function getUsername () {
    return $('username').value;
}

function getPassword () {
    return $('password').value;
}

function getService () {
    return $('service').selectedItem.id
}

function getEnabled () {
    if (window.arguments) {
        return $('enable2').selectedItem.id == 'enable2Yes';
    } else {
        return $('enable').selectedItem.id == 'enableYes';
    }
}

function chooseAdvance () {
    flock_setCharPref('flock.favorites.webservice.id', getService());
    flock_setBoolPref('flock.favorites.webservice.enabled', false);

    var fsvc = flock_getFavoritesService();
    fsvc.setWebService(null);
}

function configAdvance () {
    var fsvc = flock_getFavoritesService();

    var listener = new Object ();
    listener.onSucceeded = function () {
        $('throb').removeAttribute('throb');
        $('response').value = '';
        $('favoritesFirstRunWizard').goTo ('done');
    }
    listener.onFailed = function (msg) {
        $('throb').setAttribute('hidden', true);
        $('response').value = msg;
    }

    $('throb').removeAttribute('hidden');
    
    fsvc.webService.login (getUsername (), getPassword (), listener);

    return false;
}

function wizardFinish () {
    flock_setBoolPref('flock.favorites.askedAboutSharing', true);
    flock_setBoolPref('flock.favorites.mergeCollections', true);

    var fsvc = flock_getFavoritesService();
    fsvc.setWebServiceEnabled (getEnabled ());

    if (getEnabled()) {
        rv.success = true;
    }
}

function openWin (url) {
    window.open (url, '_new');
}

/*
function populateServiceList () {
    // populate service list
    var radiogroup = $('service');
    var fsvc = flock_getFavoritesService();
    var currentServiceId = 
        prefService.getCharPref ('flock.favorites.webservice.id');
    var services = fsvc.getWebServices ();
    while (services.hasMoreElements ()) {
        var service = services.getNext ()
            .QueryInterface (Components.interfaces.flockIFavoritesWebService);
        var hbox = document.createElement ('hbox');
        var radio = document.createElement ('radio');
        radio.value = service.id;
        radio.setAttribute ('label', service.name);
        radio.setAttribute ('class', 'service-name');
        hbox.appendChild (radio);
        var description = document.createElement ('description');
        description.control = radio;
        // FIXME: there must be a better way to make the labels line up
        description.setAttribute ('class', 'service-description');
        description.appendChild (document.createTextNode (service.description));
        hbox.appendChild (description);

        if (radio.value == currentServiceId) {
            // this is the current (ie: default) service
            if (radiogroup.hasChildNodes ()) {
                // there are already options, insert before the first one
                radiogroup.insertBefore (hbox, radiogroup.childNodes[0]);
            } else {
                // this is the first one added - just append it
                radiogroup.appendChild (hbox);
            }
            radiogroup.selectedIndex = 0
        } else {
            // just append it
            radiogroup.appendChild (hbox);
        }
    }
}
*/

function toggleServiceSelection(aTarget) {
    $('service').selectedItem = aTarget.parentNode.firstChild;
}