// vim: foldmethod=marker
flock.require('flock.favorites.favorites');
flock.require('flock.common.rdf');
flock.require('flock.common.command');


var favoritesMenuController = new CommandController({
    // all the commands
    cmd_favoriteCreateCurrent: function () {/*{{{*/
        if (!flock_getBoolPref('flock.favorites.askedAboutSharing')) {
            window.openDialog('chrome://browser/content/flock/favorites/favoritesFirstRunWizard.xul', 'Favorites First Run', 'modal');
        }

        var fav = flock.favorites.currentAsFavorite;
        fav = flock.favorites.updateOrCreateFavorite(fav);
        if (fav && flock.browser.currentFeeds) {
            flock.favorites.updateFeedsForFavorite(
                flock.browser.currentFeeds,
                fav
            );
        }
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_favoriteCreateCurrentDetailed: function () {/*{{{*/
        if (!flock_getBoolPref('flock.favorites.askedAboutSharing')) {
            window.openDialog('chrome://browser/content/flock/favorites/favoritesFirstRunWizard.xul', 'Favorites First Run', 'modal');
        }
        
        var fav = flock.favorites.currentAsFavorite;
        fav = flock.favorites.updateOrCreateFavorite(fav, true);
        if (fav && flock.browser.currentFeeds) {
            flock.favorites.updateFeedsForFavorite(
                flock.browser.currentFeeds,
                fav
            );
        }
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_favoriteGoManager: function () {/*{{{*/
        flock.browser.open('chrome://browser/content/flock/favorites/favoritesManager.xul', 'foreground_tab');
    },/*}}}*/
    cmd_favoriteGoWebService: function () {/*{{{*/
        var wsUrl = flock.favorites.webService.webView;
        if (wsUrl) {
            flock.browser.open(wsUrl);
        }
    },/*}}}*/
    cmd_favoriteEdit: function (aUrl) {/*{{{*/
        flock.favorites.editItem({url:aUrl});
    },/*}}}*/
    cmd_favoriteRemove: function (aUrl) {/*{{{*/
        flock.favorites.removeItemFromParent(aUrl);
    },/*}}}*/
    cmd_favoriteRemoveCurrent: function () {/*{{{*/
        var fav = flock.favorites.currentAsFavorite;
        flock.favorites.removeItemFromParent(fav.url);
        this.fireUpdate();
    },/*}}}*/
    cmd_favoriteViewFeeds: function (aUrl) {/*{{{*/
        flock.favorites.viewFeeds([aUrl]);
    },/*}}}*/
    cmd_collectionCreateFromTabs: {/*{{{*/
        exec: function () {
        // if tabs and valid
        // f.fav.createCollectionFrom(tabUrls)
        this.fireUpdate();
        },
    },/*}}}*/
    cmd_collectionAddCurrent: function (aEvent) {/*{{{*/
        XXX('COLLECTION TO ADD TO', aEvent.target.getAttribute('label'));
        var collection = aEvent.target.getAttribute('label');
        flock.favorites.addItemToCollection(
            flock.favorites.currentAsFavorite,
            collection
        );
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_collectionAddCurrentToNew: function () {/*{{{*/
        flock.favorites.createCollectionFrom(
            [flock.favorites.currentAsFavorite]
        );
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_viewFeedsToggle: function () {/*{{{*/
        if (!flock.browser.isFeedView) {
            flock.browser.openFeeds(
                flock.browser.currentFeeds
            );
        }
        else {
            XXX('GO BAAACK');
        }
        // isEnabled if thisPage.hasFeeds
        // if feedView goto normView
        // else goto feedView
    },/*}}}*/
    cmd_itemOpen: function (aEvent, aWhere) {/*{{{*/
        if (typeof aEvent == "string") {
            var url = aEvent;
        }
        else {
            var url = aEvent.target.getAttribute('url');
        }
        var where = aWhere;
        if (!where) {
            where = 'current';
            if (aEvent.metaKey || aEvent.ctrlKey || aEvent.button == 1) {
                where = "tab";
            }
        }
        if (flock.favorites.isFeed(url)) {
            flock.browser.openFeeds([url], where);
        }
        else {
            flock.browser.open(url, where);
        }
    },/*}}}*/

    // enable/disable stuff
    onPopupShowing: function (aEvent) {/*{{{*/
        this.updateValidUrl();
        this.updateWebService();
    },/*}}}*/
    updateValidUrl: function () {/*{{{*/
        if (flock.browser.mostRecentNavigator) {
            flock.xul.enable($('bcast_favoriteValidUrl'));   
        }
        else {
            flock.xul.disable($('bcast_favoriteValidUrl'));   
        }
    },/*}}}*/
    updateWebService: function () {/*{{{*/
        if (flock.favorites.service.getWebServiceEnabled()) {
            flock.xul.enable($('cmd_favoriteGoWebService'));
        } 
        else {
            flock.xul.disable($('cmd_favoriteGoWebService'));
        }
    },/*}}}*/
    // hits an observer
    fireUpdate: function () {/*{{{*/
        XXX('fireUpdate');
        // grab observer service
        // notify favorites:update
        flock.xpcom.notifyObservers('favorites', 'favorites:update');
    },/*}}}*/
});


function onLoad_favoritesMenu() {
    window.controllers.appendController(favoritesMenuController);
}

dojo.event.connect(window, 'onload', 'onLoad_favoritesMenu');

    
