// vim: foldmethod=marker

flock.require('flock.common.events');
flock.require('flock.favorites.favorites');
flock.require('flock.common.rdf');
flock.require('flock.common.command');

var starButtonClickHandler = new flock.xul.ClickSplitter(null, {
    onClick: function (aEvent) {/*{{{*/
        if (aEvent.button == "0") { 
            if (flock_getBoolPref('flock.favorites.addAndTagByDefault')) {
                flock.command('cmd_favoriteCreateCurrentDetailed');
            } else {
                flock.command('cmd_favoriteCreateCurrent');
            }
        }
    },/*}}}*/
    onDblClick: function (aEvent) {/*{{{*/
        flock.command('cmd_favoriteCreateCurrentDetailed');
    },/*}}}*/
});

// this is likely to be yanked out for sharing
function onLoad_favoritesOverlay() {
    var starButton = $('favoritesButton');
    starButtonClickHandler.mNode = starButton;

    // make an observer for the starbutton to watch for updates on
    flock.xpcom.addObserver('favorites', function (aSubject, aTopic) {/*{{{*/
        XXX('GOT NOTIFIED! WOOOO!!');
        starButton.updateState();
    });/*}}}*/
       
    
    var webProgressListener = new flock.browser.WebProgressListener({
        mButton: $("favoritesButton"),
        updateCreateFromTabs: function () {/*{{{*/
            if (flock.browser.currentTabs.length > 1) {
               flock.xul.enable($('cmd_collectionCreateFromTabs'));
            }
            else {
               flock.xul.disable($('cmd_collectionCreateFromTabs'));
            }
        },/*}}}*/
        updateButton: function () {/*{{{*/
            this.mButton.updateState();
        },/*}}}*/
        updateFeedButton: function () {/*{{{*/
            if (flock.browser.isFeedView) {
                flock.xul.enable($('cmd_viewFeedsToggle'));
            }
            else if (flock.browser.currentFeeds) {
                flock.xul.enable($('cmd_viewFeedsToggle'));
            } 
            else {
                flock.xul.disable($('cmd_viewFeedsToggle'));
            }
        },/*}}}*/
        onNewLocation: function (aUrl) {/*{{{*/
            this.updateCreateFromTabs();
            this.updateButton();
            
            this.updateFeedButton();   
            //flock.xul.disable($('cmd_viewFeedsToggle'));
            // reset the feed state onLocationChange
            //flock.browser.currentFeeds = [];
            //flock.browser.currentFeedInfo = [];

        },/*}}}*/
        onStopLoad: function () {/*{{{*/
            XXX('onStopLoad');
            this.updateFeedButton();
            // this really does not need to be called all that often
            if (flock.browser.currentFeeds) {
                if (flock.favorites.isFavorite(flock.browser.currentUrl)) {
                    //flock.favorites.updateFeedsForFavorite(flock.browser.currentFeeds, flock.browser.currentUrl);
                    // XXX andy: we will want to trigger a toolbar rebuild
                    //           here, too.
                }
            }
        }
    });/*}}}*/

    window.getBrowser().addProgressListener(
        webProgressListener,
        Components.interfaces.nsIWebProgressListener    
    );
    
    // this shoudl do it as soon as firefox does...
    window.getBrowser().addEventListener("DOMLinkAdded", function (aEvt) {
        webProgressListener.updateFeedButton();
    }, false);
    
};

dojo.event.connect(window, 'onload', 'onLoad_favoritesOverlay');

