// vim: foldmethod=marker ts=4 sw=4 expandtab cindent
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var oldname = null;

function flock_init () {/*{{{*/
    // set initial focus
    var name = $('name');
    name.focus ();
    name.select ();
}/*}}}*/

function flock_commit () {/*{{{*/
    var flockFavorites = flock_getFavoritesService ();
    var strBundle = document.getElementById("strBundle");
    var name = $('name');
    if (name.value == '') {
        // an empty name is not allowed
        alert (strBundle.getString("flock.favorites.collection.error.blank"));
        name.focus ();
        name.select ();
        return false;
    }
    if (flockFavorites.isCollection (name.value)) {
        // a collection of this name already exists
        alert (strBundle.getString("flock.favorites.collection.error.exists"));
        name.focus ();
        name.select ();
        return false;
    }

    // create the collection
    flockFavorites.createCollection (name.value);

    // pass the name back as a window property
    window.collectionName = name.value;

    // and as an out argument
    if (window.arguments.length) {
        window.arguments[0].value = name.value
    }

    return true;
}/*}}}*/
