//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var FlickrCalls = {
/*
    register: function() {
        PhotoAPICalls.clear();
        PhotoAPICalls.register(this);
    },
    getCall: function(aMethod) {
        return this["apicall_" + aMethod];
    },
    supportsCall: function(aMethod) {
        if(this.getCall()) return true;
        return false;
    },
*/
    apicall_getContacts:  function(aListener) { 
        var inst = FlickrCalls;
        var myListener = {
            onResult: function (aXML) {
                try {
                    var rval = inst.handleContactsResult(aXML);
                    aListener.onResult(rval);
                }
                catch(e) {
                    alert(e);
                }
            },
            onError: function (aError) {
                aListener.onError(aError);
            },
        }
        var params = new Object();
        var dict = params2Dictionary(params);
        flock.photo.service.authenticatedCall(myListener, "flickr.contacts.getList", dict);
    },
    apicall_search:  function(aListener, aUserid, aTags, aFreeText, aCount, aPage) { 
        var inst = FlickrCalls;
        var myListener = {
            onResult: function (aXML) {
                try {
                    var rval = inst.handlePhotosResult(aXML, aUserid);
                    aListener.onResult(rval);
                }
                catch(e) {
                    alert(e);
                }
            },
            onError: function (aError) {
                aListener.onError(aError);
            },
        }
        var params = new Object();
        params.user_id = aUserid;
        params.per_page = aCount;
        if(aFreeText && aFreeText.length) params.text = aFreeText;
        if(aTags && aTags.length) params.tags = aTags;
        params.page = aPage;
        params.extras = FlickrCalls.extras;
        var dict = params2Dictionary(params);
        flock.photo.service.call(myListener, "flickr.photos.search", dict);
    },
    apicall_findByUsername: function(aListener, aUserName) {
        var myListener = {
            onResult: function (aXML) {
                var user = aXML.getElementsByTagName("user")[0];
                var newUserObj = new Object();//this will reflect an xpcom interface
                newUserObj.id = user.getAttribute("id");
                newUserObj.username = aUserName;
                aListener.onResult(newUserObj);
            },
            onError: function (aXML) {
                aListener.onError(aXML);
            },
        }
        var params = new Object();
        params.username = aUserName;
        var dict = params2Dictionary(params);
        flock.photo.service.call(myListener, "flickr.people.findByUsername", dict);
    },
    handlePhotosResult: function(aXML, aUserid) {
        var rval = new Array();
        var photoList = aXML.getElementsByTagName("photo");
        for (i = 0; i < photoList.length; i++) {
            var photo = photoList[i];
            
            var id = photo.getAttribute("id");
            var server = photo.getAttribute("server");
            var secret = photo.getAttribute("secret");
            var title = photo.getAttribute("title");
            var owner_name = photo.getAttribute("ownername");
            var square_url = flock_flickrBuildPhotoUrl(server,id,secret,'square');
            var small_url = flock_flickrBuildPhotoUrl(server,id,secret,'small');
            var page_url = flock_flickrBuildPageUrl(photo.getAttribute('owner'),id);
            var newPhoto = new Photo();
            newPhoto.webPageUrl = page_url;
            newPhoto.thumbnail = square_url;
            newPhoto.midSizePhoto = small_url;
            newPhoto.title = title;
            newPhoto.id = id;
            rval.push(newPhoto);
        }    
        return rval;
    },
    handleContactsResult: function(aXML) {
        var rval = new Array();
        var contactList = aXML.getElementsByTagName("contact");
        for (i = 0; i < contactList.length; i++) {
            var contact = contactList[i];
            var nsid = contact.getAttribute("nsid");
            var username = contact.getAttribute("username");
            var family = contact.getAttribute("family");
            var friend = contact.getAttribute("friend");
            
            var newContact = new PhotoAPIUser();
            newContact.id = nsid;
            newContact.username = username;
            newContact.is_family = family;
            newContact.is_friend = friend;

            rval.push(newContact);
        }    
        return rval;
    },
    extras: "owner_name,license",
}

function flock_flickrBuildPhotoUrl(server,id,secret,size) {/*{{{*/
    var convertedSize = "";
    switch (size) {
        case "square": convertedSize = "_s"; break;
        case "thumbnail": convertedSize = "_t"; break;
        case "small": convertedSize = "_m"; break;
        case "medium": convertedSize = ""; break;
        case "large": convertedSize = "_b"; break;
        case "original": convertedSize = "_o"; break;
        default: convertedSize = "";
    }
    return "http://static.flickr.com/" + server + "/" + id + "_" + secret + convertedSize + ".jpg";
}
function flock_flickrBuildPageUrl(aUserID,aPhotoId)  {/*{{{*/
    return "http://flickr.com/photos/"+aUserID+"/"+aPhotoId;
}

flock.photo.api.calls = {};

flock.photo.api.calls.getContacts = FlickrCalls.apicall_getContacts;
flock.photo.api.calls.search = FlickrCalls.apicall_search;
flock.photo.api.calls.findByUsername = FlickrCalls.apicall_findByUsername;
