//ala termie

//flock.require('flock.common.xpcom');
//flock.load("chrome://browser/content/flock/contrib/rdfds.js");

flock.photo = {};

flock.photo.__defineGetter__("service", function () {/*{{{*/
    if (flock.photo._service) return flock.photo._service;
    flock.photo._service = flock.xpcom.getService(
        '@mozilla.org/rdf/datasource;1?name=flock-photo',
        'flockIPhotoService'
    );
    return flock.photo._service;
});/*}}}*/

flock.photo.__defineGetter__("datasource", function () {/*{{{*/
    if(flock.photo._datasource) return flock.photo._datasource;
    flock.photo._datasource = new RDFDataSource();
    flock.photo._datasource.Init(flock.photo.service);
    return flock.photo._datasource;
});/*}}}*/

flock.photo.api = {};

flock.photo.api.load = function() {
    var jsFile = flock_getCharPref("flock.photo.api.jsfile");
    if(!jsFile) {
        flock_photoSetAPI("Flickr", "FlickrCalls", "chrome://browser/content/flock/photo/flickrAPI.js", "@flock.com/?photo-api-flickr;1");
    }
    flock.photo.api.calls = {};// clear existing UI calls
    jsFile = flock_getCharPref("flock.photo.api.jsfile");
    flock.load(jsFile);
}

flock.photo.util = {};

flock.photo.util.helper = {};

flock.photo.util.__defineGetter__("gm", function () {/*{{{*/
    if (flock.photo._gm) return flock.photo._gm;
    flock.photo.util._gm = flock.xpcom.getService(
        '@flock.com/imagescaler;1',
        'flockIImageScaler'
    );
    return flock.photo.util._gm;
});/*}}}*/


flock.photo.util.createArgs = function() {
    var rval = new Array();
    for(var i=0;i<arguments.length;++i) {
        rval[i] = arguments[i] + "";
    }
    return rval;
}

flock.photo.util.resize = function(aSize, aSrc, aDest) {
    var dims = aSize + "x" + aSize;
    var args = flock.photo.util.createArgs("convert", "-size", dims, aSrc, "-resize", dims, aDest);
    flock.photo.util.gm.doMagick(args, args.length);
}

flock.photo.util.thumb = function(aSize, aSrc, aDest) {
    var dims = aSize + "x" + aSize;
    var args = flock.photo.util.createArgs("convert", aSrc, 
        "-resize", "x" + aSize*2, "-resize",  aSize*2 + "x<", 
        "-resize", "50%", "-gravity", "center", "-crop", dims + "+0+0",  aDest);
    flock.photo.util.gm.doMagick(args, args.length);
}

flock.photo.util.rotate = function(aDegrees, aSrc, aDest) {
    var args = flock.photo.util.createArgs("convert", aSrc, "-rotate", aDegrees, aDest);
    flock.photo.util.gm.doMagick(args, args.length);
}

flock.photo.util.getTmpDir = function() {
    var sinkFile = Components.classes["@mozilla.org/file/directory_service;1"]
        .getService(Components.interfaces.nsIProperties)
        .get("ProfD", Components.interfaces.nsIFile);
    sinkFile.append("flock_imagecache");
    if(!sinkFile.exists()) {
        sinkFile.createUnique(1,0700);
    }
    return sinkFile;
}

flock.photo.util.getFileFromPath = function(aPath) {
    var file = Components.classes["@mozilla.org/file/local;1"]
            .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(aPath);
    return file;
}

flock.photo.util.rename = function(aSrc, aDest) {
    var source = flock.photo.util.getFileFromPath(aSrc);
    aDest.match(/.+[\\\/](.+)/);
    source.leafName = RegExp.$1;
    dump("HEERRR " + source.leafName + "\n");
}

flock.photo.util.exify = function(aSrc, aDest) {
    var args = flock.photo.util.createArgs("convert", aSrc, aSrc + ".exif");
    flock.photo.util.gm.doMagick(args, args.length);
    args = flock.photo.util.createArgs("convert", aSrc, aSrc + ".exif");
    flock.photo.util.rename(aSrc + ".exif", aSrc + ".exif.app1");
}

flock.photo.util.removeFileBySpec = function(aSpec, aRecursive) {
    dump(aSpec + "\n");
    try {
        var file = flock.photo.util.getFileFromURL(aSpec);
        file.remove(aRecursive);
    }
    catch(e) {
    }
}

flock.photo.util.removeFileByPath = function(aPath, aRecursive) {
    dump(aPath + "\n");
    try {
        var file = flock.photo.util.getFileFromPath(aPath);
        file.remove(aRecursive);
    }
    catch(e) {
    }
}

flock.photo.util.getFileFromPath = function(aPath) {
    var file = Components.classes["@mozilla.org/file/local;1"]
            .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(aPath);
    return file;
}

flock.photo.util.getFileFromURL = function(aURL) {
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
        .getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file")
        .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    var sourceSpec = fileHandler.getFileFromURLSpec(aURL);
    var sourceFile = Components.classes["@mozilla.org/file/local;1"]
        .createInstance(Components.interfaces.nsILocalFile);
    sourceFile.initWithFile(sourceSpec);
    return sourceFile;
}

flock.photo.util.callCount = 0;
flock.photo.util.getUniqueFname = function(aFName) {
    aFName.match(/.+\.(.+)/);
    var ext = RegExp.$1;
    if(!ext) ext = "";
    var now = new Date();
    var sinkFileName = hex_md5(aFName + now + flock.photo.util.callCount++);
    sinkFileName = sinkFileName + "." + ext;
    return sinkFileName;
}
