/*
     BEGIN FLOCK GPL
     
     Copyright Flock Inc. 2005
     http://flock.com
     
     This file may be used under the terms of of the
     GNU General Public License Version 2 or later (the "GPL"),
     http://www.gnu.org/licenses/gpl.html
     
     Software distributed under the License is distributed on an "AS IS" basis,
     WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
     for the specific language governing rights and limitations under the
     License.
     
     END FLOCK GPL
*/

flock.require('flock.photo.photoCommon');

const FLOCK_PHOTO_BROWSE_URN = "urn:flock:photo:search";

var gPageSize = 50;
var gFinishedQuery = false;
var gUser = null;
var gPage = 1;
var gQuery = "";
var gDirty = false;
var gBrowseResult = null;

////////////////////////////////////////////////////////////////////////////////////////
// Upload stuff
////////////////////////////////////////////////////////////////////////////////////////

function flock_photoTopbarLoad() {
	flock.photo.api.load();
	window.flock_photoBrowserGetContactsPhotos = flock_photoBrowserGetContactsPhotos;
	window.flock_photoBrowseGetMine = flock_photoBrowseGetMine;
	window.flock_photoBrowseSearch = flock_photoBrowseSearch;
	window.flock_photoBrowseOnChange = flock_photoBrowseOnChange;
	
    gFinishedQuery = false;
    var ui = $("flock-photo-browse-slideybox");
    ui.ref=FLOCK_PHOTO_BROWSE_URN;
    ui.builder.rebuild();
    flock_photoBrowserSetSearch("tag");
    flock_photoBrowseLoadPrefs();
    flock_photoDoFirstRun();
    ui.setListener(PhotoBrowseScrolleyboxListener);
}

function flock_photoTopbarUnload() {
	flock_photoCommonUnload();
}

////////////////////////////////////////////////////////////////////////////////////////
// Browse stuff
////////////////////////////////////////////////////////////////////////////////////////



function flock_photoBrowseReset() {
    gDirty = false;
    gPage = 1;
    var ds = flock.photo.datasource;
    ds.deleteDescendents(FLOCK_PHOTO_BROWSE_URN);
    gFinishedQuery = false;
    var ui = $("flock-photo-browse-slideybox");
    ui.canscrollright=true;
    ui.scrollHome();
    gBrowseResult = new Array();
}

function flock_photoDoFirstRun() {
    var ran = flock_getBoolPref("flock.photo.firstrun.ran");
    if(!ran) {
        flock_setBoolPref("flock.photo.firstrun.ran", true);
        var demoUser = flock_getCharPref("flock.photo.firstrun.user");
        if(!demoUser) demoUser = "Join the Flock";
        $$("flock-photo-username").value = demoUser;
        flock_photoBrowseSearch();
    }
}

function flock_photoBrowseLoadPrefs() {
    //hateful function
    var username = flock_getCharPref("flock.photo.search.username");
    var term = flock_getCharPref("flock.photo.search.term");
    var mode = flock_getCharPref("flock.photo.search.mode");
    if(username) {
        $$("flock-photo-username").value = username;
    }
    if(term) {
        $$("flock-photo-searchbox").value = term;
    }
    if(mode) {
		flock_photoBrowserSetSearch( mode );
    }
}

var PhotoBrowseScrolleyboxListener = {
    onDrop: function(aSelection, aHoverChild) {
    },
    onScrollLeft: function() {
    },
    onScrollRight: function() {
        if(gUser) {
            var pagesLeft = $("flock-photo-browse-slideybox").pagesLeft;
            if(pagesLeft<3.3) {
                PhotoBrowsePhotosGetter.exec(gUser,gPage);
            }
        }
    },
    onRemoveSelectionLeft: function() {
    },
    onRemoveSelection: function(aSelection) {
        dump("onRemove Selection\n");
        var svc = flock_photoGetService();
        for(var i=0;i<aSelection.length;++i) {
            var child = aSelection[i].firstChild;
            svc.removePhotoUpload(child);
        }
    },
}

var PhotoBrowseUserIdGetter = {
    onResult: function(aUser) {
        this.inProgress = false;
        try {
            gUser = aUser;
            this.inProgress = false;
            flock_photoBrowseReset();
            PhotoBrowsePhotosGetter.exec(gUser,gPage);
//          document.persist("flock-photo-contacts" , "value");
        } catch(e) {
            alert(e);
        }
    },
    onError: function(aError) {
        this.inProgress = false;
        flock_setStatus("user not found");
    },
    inProgress: false,
    exec: function(aUsername) {
        if(this.inProgress) return;
        this.username = aUsername;
        flock_setStatus("finding user");
        gUser = null;
        this.inProgress = true;
        flock.photo.api.calls["findByUsername"](this, aUsername);
    },
}

var PhotoBrowsePhotosGetter = {
    onResult: function(aResult) {
        //persist attributes the old fashioned way
        flock_setCharPref("flock.photo.search.username", this.username);
        flock_setCharPref("flock.photo.search.term", this.term);
        flock_setCharPref("flock.photo.search.mode", this.mode);

        this.inProgress = false;
        if(gPage==1 && aResult.length==0) flock_setStatus("no images found");
        else flock_setStatus(null);
        gPage++;
        try {
            flock_photoBrowseProcess(aResult);
        }
        catch(e) {
            alert(e);
        }
    },
    onError: function(aError) {
        this.inProgress = false;
        flock_setStatus("error message goes here");
    },
    inProgress: false,
    exec: function(aUser, aPage) {
        if(this.inProgress) return;
        this.inProgress = true;
        var tag = null;
        var text = null;
        if(gPage==1) flock_setStatus("retrieving");
        if(gSearchMode=="tag") {
            tag = $$('flock-photo-searchbox').value;
        }
        else {
            text = $$('flock-photo-searchbox').value;
        }

        this.term = $$('flock-photo-searchbox').value;
        this.mode = gSearchMode;

        this.username = "";
        var id = "";
        if(aUser) {
            id = aUser.id;
            this.username = aUser.username;
        }
        flock.photo.api.calls["search"](this, id, tag, text, gPageSize, aPage);
    },
}

function flock_setStatus(aStatus) {
    if(aStatus) {
        $("flock-photo-browse-status").removeAttribute("collapsed");
        $("flock-photo-browse-status").value = aStatus;
    }
    else {
        $("flock-photo-browse-status").setAttribute("collapsed", true);
    }
}

function flock_photoBrowseGetUserID(aUsername) {
    gPage = 1;
    PhotoBrowseUserIdGetter.exec(aUsername);
}
function flock_photoBrowseProcessTimer() {
    if(gBrowseResult.length) {
        var ds = flock.photo.datasource;
        var root = ds.getNode(FLOCK_PHOTO_BROWSE_URN);
        root.makeSeq();

        var photo = gBrowseResult.shift();
        var id = photo.id;
        var node = ds.getNode(FLOCK_PHOTO_BROWSE_URN+":" + id);
        
        node.addTargetOnce(_fns('thumbnail'), photo.thumbnail + "");
        node.addTargetOnce(_fns('midSizePhoto'), photo.midSizePhoto + "");
        node.addTargetOnce(_fns('webPageUrl'), photo.webPageUrl + "");
        node.addTargetOnce(_fns('title'), photo.title + "");
        node.addTargetOnce(_fns('photoid'), photo.id + "");
        root.addChild(node);
        window.setTimeout("flock_photoBrowseProcessTimer();",75);
    }
    else {
        flock_photoGetService().save();
    }
}

function flock_photoBrowseProcess(aResult) {
    gBrowseResult = gBrowseResult.concat(aResult);
    flock_photoBrowseProcessTimer();
    return;
    
    var ds = flock.photo.datasource;
    var root = ds.getNode(FLOCK_PHOTO_BROWSE_URN);
    root.makeSeq();
    for (i = 0; i < aResult.length; i++) {
        var photo = aResult[i];
        
        var id = photo.id;
        var node = ds.getNode(FLOCK_PHOTO_BROWSE_URN+":" + id);
        
        node.addTargetOnce(_fns('thumbnail'), photo.thumbnail + "");
        node.addTargetOnce(_fns('midSizePhoto'), photo.midSizePhoto + "");
        node.addTargetOnce(_fns('webPageUrl'), photo.webPageUrl + "");
        node.addTargetOnce(_fns('title'), photo.title + "");
        node.addTargetOnce(_fns('photoid'), photo.id + "");
        root.addChild(node);
    }    
    var ui = $("flock-photo-browse-slideybox");
    ui.builder.rebuild();
    if(aResult.length!=gPageSize) gFinishedQuery = true;
    flock_photoGetService().save();
}

function flock_photoBrowseSearch() {
    if(gDirty) flock_photoBrowseReset();
    if(gUser && gUser.username!=$$("flock-photo-username").value) {
        flock_photoBrowseReset();
        gUser = null;
    }

    if($$("flock-photo-username").value.length) {
        flock_photoBrowseGetUserID($$("flock-photo-username").value);
    }
    else {
        PhotoBrowsePhotosGetter.exec(gUser,gPage);
    }
}

var photoBrowseDNDObserver = new DNDObserver();

photoBrowseDNDObserver.onDragStart = function (aEvent, aXferData, aDragAction) {/*{{{*/
    try {
        var pageUrl = aEvent.target.webPageUrl;
        var html = aEvent.target.photoHTML;
        var title = aEvent.target.title;
        if (!title) {
            title = "";
        }
        XXX("url,html,title",pageUrl,html,title);
        aXferData.data = new TransferData();
        aXferData.data.addDataForFlavour("text/x-moz-url", pageUrl + "\n" + title);
        aXferData.data.addDataForFlavour("text/html", html);
    } catch (e) {
        XXX("ERROOORRROOROROROR",e);
    }
}/*}}}*/

photoBrowseDNDObserver.getSupportedFlavours = function () {/*{{{*/
        var flavourSet = new FlavourSet();
        flavourSet.appendFlavour("text/x-moz-url");
        flavourSet.appendFlavour("text/html");
        return flavourSet;                           
}/*}}}*/


function flock_photoBrowseOnChange(aEvent) {
    gDirty = true;
    if(aEvent.keyCode==aEvent.DOM_VK_RETURN) {
        flock_photoBrowseSearch();
    }
}
function flock_photoBrowserSetSearch(aMode) {
	if (aMode == 'text') {
     	$$('search-menu').style.backgroundImage = 'url(chrome://browser/skin/flock/common/searchAll.png)';
	} else {
     	$$('search-menu').style.backgroundImage = 'url(chrome://browser/skin/flock/common/searchTags.png)';
    }
    gSearchMode = aMode;
}

function flock_photoBrowserGetContactsPhotos(aUsername, aID) {
    flock_photoBrowseReset();
	
    $$("flock-photo-username").value = aUsername;
    var user = {
        username: aUsername,
        id: aID,
    }
    gUser = user;
    PhotoBrowsePhotosGetter.exec(user,gPage);
}

function flock_photoBrowseGetMine() {
    var user = flock.photo.service.getAuthUser();
    flock_photoBrowserGetContactsPhotos(user.username, user.id);
}
