var gPhotoState = "loggedout";

top.addEventListener("load", function() {
    flock.photo.api.load();
    flock.photo.service.addListener(AuthListener);
    flock_photoUpdateLoggedInState();
}, false);

top.addEventListener("unload", function() {
    flock.photo.service.removeListener(AuthListener);
}, false);

function flock_PhotoTopbarSelectExtension(aSelect) {
    flock_photoUpdateLoggedInState();
    if(aSelect=="browse") {
        $('flock_PhotoBrowseTopbarUI').removeAttribute("hidden");
        $('flock_PhotoUploadTopbarUI').setAttribute("hidden", true);
    }
    else {
        $('flock_PhotoBrowseTopbarUI').setAttribute("hidden", true);
        $('flock_PhotoUploadTopbarUI').removeAttribute("hidden");
    }
    window.setTimeout("window.document.commandDispatcher.updateCommands('focus')",0);
}

var gPhotoLoginListener = new PhotoLoginListener();

function flock_photoTryLogin() {
    if(gPhotoLoginListener.inProgress) {
        return;
    }
    else {
        gPhotoLoginListener.inProgress = true;
        flock.photo.service.login(gPhotoLoginListener);
    }
}

var AuthListener = {
    onUploadStart: function (aCurrentUpload, aCount, aMax) {
    },
    onUpload: function (aCurrentUpload, aCount, aMax) {
    },
    onUploadAdd: function (aCurrent) {
    },
    onUploadRemove: function () {
    },
    onUploadComplete: function () {
    },
    onUploadError: function (aUpload, aCount, aMax, aError) {
    },
    onAuthStateChange: function(aState) {
        flock_photoUpdateLoggedInState();
    },
}

function flock_photoSetAuthState(aState) {
    for(var i=0;i<$("flock-photo-topbar-authstuff").childNodes.length;++i) {
        var child = $("flock-photo-topbar-authstuff").childNodes.item(i);
        child.setAttribute("hidden", true);
    }
    $("flock-photo-topbar-" + aState).removeAttribute("hidden");
}

function flock_photoClearContacts() {
    var ds = flock.photo.datasource;
    var root = ds.getNode(FLOCK_PHOTO_CONTACTS_URN);
    ds.deleteRecursive(root);
    flock.photo.service.save();
}

function flock_photoUpdateLoggedInState() {
    var flockIPhotoAPI = Components.interfaces.flockIPhotoAPI;
    try {
        if(!flock.photo.service.api.isLoggedIn()) {
            flock_photoSetAuthState("loggedout");
            $("flock-photo-topbar-loggedout").removeAttribute("hidden");
            $("flock-photo-topbar-name-label").value = "";
            $("flock-photo-contacts-menu").setAttribute("disabled", true);
        }
        switch(flock.photo.service.api.getAuthState()) {
            case flockIPhotoAPI.LOGGED_OUT:
            break;
            case flockIPhotoAPI.LOGGING_IN:
                flock_photoSetAuthState("logging-in");
            break;
            case flockIPhotoAPI.LOGGED_IN:
                $("flock-photo-topbar-logging-in").setAttribute("hidden", true);
                flock_photoSetAuthState("loggedin");
                $("flock-photo-topbar-name-label").value = flock.photo.service.getAuthUser().username;
                $("flock-photo-contacts-menu").removeAttribute("disabled");
                if(flock.browser.currentWindowIsMostRecent())  {
                    PhotoBrowseContactsGetter.exec();
                }
            break;
            case flockIPhotoAPI.LOGIN_ERROR:
                flock_photoSetAuthState("loggedout");
            break;
        }
    }
    catch(e) { XXX('Error common code logged in state', e) }
}
const FLOCK_PHOTO_CONTACTS_URN = "urn:flock:photo:contacts";

var PhotoBrowseContactsGetter = {
    onResult: function(aResult) {
        this.inProgress = false;
        $("flock-photo-loading-contacts").setAttribute("hidden", true);
        var ds = flock.photo.datasource;
        var root = ds.getNode(FLOCK_PHOTO_CONTACTS_URN);
        root.makeSeq();
        var FORMHISTSVC = Components.classes["@mozilla.org/satchel/form-history;1"] .getService(Components.interfaces.nsIFormHistory);
        FORMHISTSVC.removeEntriesForName("flock-photo-contacts");
        for (i = 0; i < aResult.length; i++) {
            var contact = aResult[i];
            
            var id = contact.id;
            var username = contact.username;
            var node = ds.getNode(FLOCK_PHOTO_CONTACTS_URN+":" + id);
            FORMHISTSVC.addEntry("flock-photo-contacts", username);
            
            node.addTargetOnce(_fns('id'), contact.id + "");
            node.addTargetOnce(_fns('username'), contact.username + "");
            node.addTargetOnce(_fns('is_friend'), contact.is_friend + "");
            node.addTargetOnce(_fns('is_family'), contact.is_family + "");
            root.addChild(node);
        }    
        flock.photo.service.save();
    },
    onError: function(aError) {
        this.inProgress = false;
    },
    inProgress: false,
    exec: function() {
        if(this.inProgress) return;
        flock_photoClearContacts();
        $("flock-photo-loading-contacts").removeAttribute("hidden");
        this.inProgress = true;
        flock.photo.api.calls["getContacts"](this);
    },
}
