//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//
var gElement = null;
var gSelection = null;
var gLocalSelection = null;
const gMaxPhotoWidth = 400;
const gMaxPhotoHeight = 300;

var gWidth = 0;
var gHeight = 0;

function flock_PhotoPropertiesGetFirstElement() {
    return
}

function flock_photoPropertiesLoad() {
    gSelection = window.arguments[0];
    if(gSelection.length > 1) { // group edit
        flock_photoPropertiesMulti();
    } else { // single photo edit
        gElement = gSelection[0];
        flock_photoSetupImage();
    }
}

function flock_photoResetSelection() {
    for(var i=0;i<gSelection.length;++i) {
        gSelection[i].firstChild.setAttribute("selected", true);
    }
}

function flock_photoPropertiesMulti() {
    //$("image-deck").setAttribute("style", "visibility: collapse");
    $("image-deck").selectedIndex = 1;
    $("image-box").setAttribute("collapsed", true);
    $("next").setAttribute("disabled", true);
    $("prev").setAttribute("disabled", true);
    //$("multi-image").setAttribute("style", "visibility: collapse");
    //window.setTimeout("flock_photoResetSelection()", 0);
    gLocalSelection = new Array();
    
    var title, description, tags, pub, friends, family;
    
    title = gSelection[0].firstChild.getAttribute("title");
    description = gSelection[0].firstChild.getAttribute("description");
    tags = gSelection[0].firstChild.getAttribute("tags").split(",").sort().join(",");
    pub = gSelection[0].firstChild.getAttribute("is_public");
    friends = gSelection[0].firstChild.getAttribute("is_friend");
    family = gSelection[0].firstChild.getAttribute("is_family");

    for(var i = 0; i < gSelection.length; ++i) {
        //var newElement = gSelection[i].cloneNode(true);
        var newElement = document.createElement("vbox");
        newElement.appendChild(document.createElement("photo"));
        $("multi-image").appendChild(newElement);
        newElement.firstChild.setAttribute("thumbnail", gSelection[i].firstChild.thumbFileSpec);
        //newElement.firstChild.setAttribute("selected", true);
        gLocalSelection[i] = newElement;
        newElement.firstChild.photoUpdate();
        //gSelection[i] = newElement;
        
        // check for common group properties
        title = gSelection[i].firstChild.getAttribute("title") == title ? title : null;
        description = gSelection[i].firstChild.getAttribute("description") == description ? description : null;
        tags = gSelection[i].firstChild.getAttribute("tags").split(",").sort().join(",") == tags ? tags : null;
        pub = gSelection[i].firstChild.getAttribute("is_public") == pub ? pub : null;
        friends = gSelection[i].firstChild.getAttribute("is_friend") == friends ? friends : null;
        family = gSelection[i].firstChild.getAttribute("is_family") == family ? family : null;
    }
    
    $("title").value = title;
    $("description").value = description;
    $("tags").value = tags;
    
    if (pub) {
        if (pub == "false") {
            if (friends && family) {
                flock_photoPropertiesSetPrivacy("private");
                if (friends == "true") $('is_friend').checked = true;
                if (family == "true") $('is_family').checked = true;
            } else {
                $('is_friend').disabled = true;
                $('is_family').disabled = true;
            }
        }
        if (pub == "true") {
            flock_photoPropertiesSetPrivacy("public");
            $('is_friend').disabled = true;
            $('is_family').disabled = true;
        }
    } else {
        $('is_friend').disabled = true;
        $('is_family').disabled = true;
    }
    
    // update layout for group edit
    $("title_change").removeAttribute("collapsed");
    $("description_change").removeAttribute("collapsed");
    $("tags_change").removeAttribute("collapsed");
    $("permissions_change").removeAttribute("collapsed");
    // add change listeners
    $("title").setAttribute("oninput", "$('title_change').checked = true");
    $("description").setAttribute("oninput", "$('description_change').checked = true");
    $("tags").setAttribute("oninput", "$('tags_change').checked = true");
    var changeListener = {
        handleEvent: function(e) {
            dump(e.type + "\n");
            switch(e.type) {
                case "RadioStateChange":
                case "CheckboxStateChange":
                    $("permissions_change").checked = true;
                    break;
            }
            
        }
    }
    $("is_public").addEventListener("RadioStateChange", changeListener, false);
    $("is_friend").addEventListener("CheckboxStateChange", changeListener, false);
    $("is_family").addEventListener("CheckboxStateChange", changeListener, false);
    
    $("title").focus();
}

function flock_photoPropertiesUnload() {
}

function flock_photoSetupImageDimensions() {
    return;
    if(gSelection.length>1) return;
    $("image").removeAttribute("width");
    $("image").removeAttribute("height");
    
    var scaleFactor = gHeight/gMaxPhotoHeight;

    if(gWidth/scaleFactor > gMaxPhotoWidth) {
        $("image").setAttribute("width", gMaxPhotoWidth);
    }
    else {
        $("image").setAttribute("height", gMaxPhotoHeight);
    }
}

function flock_photoSetupImage() {
    var path = gElement.firstChild.getAttribute("previewFilePath");
//    var imageUtils =  flock_getImageUtils();
    var x = {};
    var y = {};

//    var dimensions = imageUtils.getDimensions(path, x,y);
//    gWidth = x.value;
//    gHeight = y.value;
//    flock_photoSetupImageDimensions();

    $("image").src = gElement.firstChild.getAttribute("previewFileSpec");
    if(!gElement.nextSibling) {
        $("next").setAttribute("disabled", true);
    }
    if(!gElement.previousSibling || gElement.previousSibling.nodeName=="template") {
        $("prev").setAttribute("disabled", true);
    }

    $("title").value = gElement.firstChild.getAttribute("title");
    $("description").value = gElement.firstChild.getAttribute("description");
    $("tags").value = gElement.firstChild.getAttribute("tags");

    var is_public = gElement.firstChild.getAttribute("is_public");
    var is_family = gElement.firstChild.getAttribute("is_family");
    var is_friend = gElement.firstChild.getAttribute("is_friend");

    if(is_public=="false") {
        flock_photoPropertiesSetPrivacy("private");
    }
    else {
        flock_photoPropertiesSetPrivacy("public");
    }

    if(is_family=="true") {
        $("is_family").checked = true;
    } 
    else {
        $("is_family").checked = false;
    }
    if(is_friend=="true") {
        $("is_friend").checked = true;
    } 
    else {
        $("is_friend").checked = false;
    }
    
    gElement.parentNode.clearSelection();
    gElement.selected=true;
    gElement.parentNode.ensureElementIsVisible(gElement);
    $("title").focus();
    OriginalData.remember();
}

var OriginalData = {
    hasChanged: function(aID) {
        if($(aID).nodeName=="checkbox") {
            if(this[aID]==$(aID).checked) return false;
        }
        else {
            if(this[aID]==$(aID).value) return false;
        }
        //dump("has changed " + aID + " " + this[aID] + " " + $(aID).value + "\n");
        return true;
    },
    remember: function() {
        this.title = $('title').value;
        this.tags = $('tags').value;
        this.description = $('description').value;
        this.is_public = $('is_public').value;
        this.is_friend = $('is_friend').checked;
        this.is_family = $('is_family').checked;
    },
}

function flock_photoPropertiesPrev() {
    flock_photoPropertiesSync();
    $("next").removeAttribute("disabled");
    $("prev").removeAttribute("disabled");
    gElement = gElement.previousSibling;
    flock_photoSetupImage();
}
            
function flock_photoPropertiesNext() {
    flock_photoPropertiesSync();
    $("next").removeAttribute("disabled");
    $("prev").removeAttribute("disabled");
    gElement = gElement.nextSibling;
    flock_photoSetupImage();
}
            
function flock_photoPropertiesSync() {
    var element;

    if(gSelection.length > 1) {
        for (var i=0; i<gSelection.length; i++) {
            element = gSelection[i];
            
            if ($("title_change").checked) {
                element.firstChild.setAttribute("title", $("title").value);
            }
            if ($("description_change").checked) {
                element.firstChild.setAttribute("description", $("description").value);
            }

            if ($("tags_change").checked) {
                element.firstChild.setAttribute("tags", $("tags").value);
            }
            if ($("permissions_change").checked) {
                element.firstChild.setAttribute("is_public", $("is_public").value=="public");
                element.firstChild.setAttribute("is_friend", $("is_friend").checked);
                element.firstChild.setAttribute("is_family", $("is_family").checked);
            }
        }
    } else {
        element = gElement;
        if(OriginalData.hasChanged("title")) element.firstChild.setAttribute("title", $("title").value);
        if(OriginalData.hasChanged("description")) element.firstChild.setAttribute("description", $("description").value);
        if(OriginalData.hasChanged("tags")) element.firstChild.setAttribute("tags", $("tags").value);
        if(OriginalData.hasChanged("is_public")) element.firstChild.setAttribute("is_public", $("is_public").value=="public");
        if(OriginalData.hasChanged("is_friend")) element.firstChild.setAttribute("is_friend", $("is_friend").checked);
        if(OriginalData.hasChanged("is_family")) element.firstChild.setAttribute("is_family", $("is_family").checked);
        flock_photoPropertiesSave(element);
    }

    flock.tags.addTagElementsToFormHistory($("tags").pills);
}

function flock_photoPropertiesRotateRight() {
    if(gSelection.length>1) {
        for(var i=0;i<gSelection.length;++i) {
            flock_photoPropertiesRotate(gSelection[i], 90, gLocalSelection[i]);
        }
    }
    else {
        flock_photoPropertiesDoRotate(gElement, 90);
    }
}

var gRotateQ = new Array();
var gRotating = false;

function flock_photoPropertiesRotateLeft() {
    if(gSelection.length>1) {
        for(var i=0;i<gSelection.length;++i) {
            flock_photoPropertiesRotate(gSelection[i], 270, gLocalSelection[i]);
        }
    }
    else {
        flock_photoPropertiesDoRotate(gElement, 270);
    }
}

function flock_photoRotateTimer() {
    if(gRotateQ.length) {
        var rotateObj = gRotateQ.pop();
        flock_photoPropertiesDoRotate(rotateObj.element, rotateObj.degrees);

        if(rotateObj.thumbnail) {
            rotateObj.thumbnail.firstChild.setAttribute("thumbnail", rotateObj.element.firstChild.thumbFileSpec);
            rotateObj.thumbnail.firstChild.photoUpdate();
        }
        window.setTimeout("flock_photoRotateTimer()", 200);
    }
    else {
        if(gSelection.length>1) {
            $("rotateLeft").removeAttribute("disabled");
            $("rotateRight").removeAttribute("disabled");
//            $("remove").removeAttribute("disabled");
            $("cancel").removeAttribute("disabled");
            $("ok").removeAttribute("disabled");
        }
        gRotating = false;
    }
}

function flock_photoPropertiesRotate(aElement, aDegrees, aThumbnail) {
    var uploadObj = {
        element: aElement,
        thumbnail: aThumbnail,
        degrees: aDegrees,
    }
    gRotateQ.unshift(uploadObj);
    if(!gRotating) {
        gRotating = true; 
        if(gSelection.length>1) {
            $("rotateLeft").setAttribute("disabled",true);
            $("rotateRight").setAttribute("disabled",true);
//            $("remove").setAttribute("disabled",true);
            $("cancel").setAttribute("disabled",true);
            $("ok").setAttribute("disabled",true);
        }
        window.setTimeout("flock_photoRotateTimer()", 0);
    }
}


function flock_photoPropertiesDoRotate(aElement, aDegrees) {
    aElement.firstChild.rotationInt = aElement.firstChild.rotationInt + aDegrees;

    var imageUtils =  flock_getImageUtils();
    var previewPath = aElement.firstChild.getAttribute("previewFilePath");
    var thumbPath = aElement.firstChild.getAttribute("thumbFilePath");
    var newPreviewFileName = flock.photo.util.getUniqueFname(previewPath);
    var newThumbFileName = flock.photo.util.getUniqueFname(thumbPath);

    var newPreviewFile = flock_getTmpFile(newPreviewFileName);
    var newThumbFile = flock_getTmpFile(newThumbFileName);

    var newThumbPath = flock.photo.util.getUniqueFname(thumbPath);
    //var args= flock.photo.util.createArgs("convert", thumbPath, "-rotate", aElement.firstChild.rotationInt, newThumbFile.path);
    flock.photo.util.rotate(aElement.firstChild.rotationInt, thumbPath, newThumbFile.path);

    //imageUtils.doMagick(args, args.length);
    //args= flock.photo.util.createArgs("convert", originalPath, "-rotate", aElement.firstChild.rotationInt, newOriginalFile.path);
    //imageUtils.doMagick(args, args.length);
    flock.photo.util.rotate(aElement.firstChild.rotationInt, previewPath, newPreviewFile.path);

    var toDelete1 = aElement.firstChild.getAttribute("previewFileSpec");
    var toDelete2 = aElement.firstChild.getAttribute("thumbFileSpec");

    var src = flock_getURLFromFile(newThumbFile);
    aElement.firstChild.setAttribute("thumbFileSpec", src);
    aElement.firstChild.setAttribute("src", src);
    aElement.firstChild.photoUpdate();

    var spec = flock_getURLFromFile(newPreviewFile);
    aElement.firstChild.setAttribute("previewFileSpec", spec)
    $("image").src = spec;

    var tmp = gWidth;
    gWidth = gHeight;
    gHeight = tmp;

    if(!toDelete1.match("preview")) {//hack, the first time we rotate, the spec==the original file
        flock.photo.util.removeFileBySpec(toDelete1);
        flock.photo.util.removeFileBySpec(toDelete2);
    }

    flock_photoSetupImageDimensions();
    flock_photoPropertiesSave(aElement);
}

function flock_photoPropertiesSave(aElement) {
    var svc = flock.photo.service;
    svc.savePhotoUpload(aElement.firstChild);
}

function flock_photoPropertiesSetPrivacy(aVal) {
    $('is_public').value = aVal;
    if(aVal=="private") {
        $('is_friend').disabled = false;
        $('is_family').disabled = false;
    }
    else {
        $('is_friend').disabled = true;
        $('is_family').disabled = true;
    }
}

function flock_photoPropertiesRemove() {

    var svc = flock.photo.service;
    if(gSelection.length>1) {
        for(var i=0;i<gSelection.length;++i) {
            svc.removePhotoUpload(gSelection[i].firstChild);
        }
        window.close();
        return;
    }

    $("next").removeAttribute("disabled");
    $("prev").removeAttribute("disabled");
    var tmp = gElement;

    gElement = tmp.nextSibling;
    if(!gElement) {
        gElement = tmp.previousSibling;
    }

    if(gElement && gElement.nodeName!="slideyitem") gElement=null;

    svc.removePhotoUpload(tmp.firstChild);
    if(gElement==null) {
        window.close();
        return;
    }
    flock_photoSetupImage();
}
