//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

flock.require('flock.common.xpcom');

window.last_dragged_selection='';
window.next_shelfobject = '';

var shelfObserver={
	onDragOver: function(event,flavor,session){
	},

	onDrop: function(evt,dropData,asession){
           // XXX('Dropped on the shelf !!');
           var data=flock_getMarkedUpSelection(evt,dropData,asession);
	   add_object(data);
	},

	 onDragStart: function(event, transferData, action){
            var tree = event.currentTarget;
            var selectedItems = flock_getTreeSelectionFromDrag(event, tree, ["srcCol"]);
            if(!selectedItems) return false;
            if(selectedItems.length == 0) return false;
            XXX("drag from the shelf (list view)");
            var src = "";

            if (selectedItems.length == 1) {
                src = selectedItems[0]["srcCol"];
                XXX("One element ", src);
            } else {
               XXX("Several elts ", selectedItems.length);
               for (var i = 0; i < selectedItems.length; ++i) {
        	        var item = selectedItems[i];
		        src = src + "<p>"+item["srcCol"]+"</p>";
                        XXX(i+" "+src);
		}
    	    }
            transferData.data=new TransferData();
            transferData.data.addDataForFlavour("flock/shelfobject",src);
            transferData.data.addDataForFlavour("text/html",src);
            transferData.data.addDataForFlavour("text/unicode",src);
	 },

	 getSupportedFlavours: function(){
			flavors=new FlavourSet();
			//flavors.appendFlavour('flock/shelfobject');
			flavors.appendFlavour('text/unicode');
			flavors.appendFlavour('text/html');
			flavors.appendFlavour('text/x-moz-url');
			flavors.appendFlavour('application/x-moz-file','nsIFile');
			return flavors;
	 }
}

var shelfIconObserver={
    onDragStart: function(event, transferData, action){
        //for (i in event.target){ XXX('event.target '+i, event.target[i]); }
        src=event.target.src;
        dump('DRAGGING SOURCE: ' + src + '\n');
        transferData.data=new TransferData();
        transferData.data.addDataForFlavour("flock/shelficon",src);
        transferData.data.addDataForFlavour("text/html",src);
        transferData.data.addDataForFlavour("text/unicode",src);
    }
}

var IconViewSlideyboxListener = {
    onDrop: function(aSelection, aHoverChild) {
    },
    onScrollRight: function() {
	// XXX("Shelf scrolley: onScrollRight");
    },
    onRemoveSelectionLeft: function() {
    },
    onRemoveSelection: function(aSelection) {
        dump("onRemove Selection\n");
        for(var i=0;i<aSelection.length;++i) {
            var child = aSelection[i].firstChild;
   	    flock.shelf.service.remove(child.id.split(':').pop());
        }
    },
}

// Observe changes on the datasource
var shelfRdfObserver = {
    onAssert            : function(ds, source, predicate, target){
                            redraw_shelf();
                          },
    onUnassert          : function(ds, source, predicate, target){
                            redraw_shelf();
                          },
    onChange            : function(ds, source, predicate, oldTarget, newTarget){
                            redraw_shelf();
                          },
    onMove              : function(ds, oldSource, newSource, predicate, target){},
    onBeginUpdateBatch  : function(ds){},
    onEndUpdateBatch    : function(ds){}
}

function init_shelf(){
    var tree = $('list_view');

    // Tree Controller (List View)
    var treeController = new CommandController({
        isDebug: false,
        debugCommands: ["cmd_return", "cmd_delete"],
        debugFromCommandset: 'flock_shelfElementCommands',
        cmd_delete: function () { goDoCommand('cmd_shelfElementRemove'); },
        cmd_return: function () { goDoCommand('cmd_shelfElementOpen'); },
        cmd_shelfElementRemove: function () {/*{{{*/
            var tree = $('list_view');
            var treeSelection = flock_getTreeSelection(tree, ["idCol"]);
            for (var i = 0; i < treeSelection.length; ++i) {
                var item = treeSelection[i];
                flock.shelf.service.remove(item["idCol"]);
            }
        },/*}}}*/ 
        cmd_shelfElementOpen: function () { /*{{{*/
            var selectedItems = flock_getTreeSelection($('list_view'), ["typeCol","urlCol","idCol"]);
            var item = selectedItems[0];
            if (item["typeCol"].toString() == "note") {
               window.openDialog("chrome://browser/content/flock/shelf/addShelfNoteDlg.xul", "addNote", "modal", item["idCol"]);
            } else {
               flock.browser.open(item["urlCol"]);
            }
        },/*}}}*/
        cmd_shelfElementOpenInTab: function () { /*{{{*/
            var selectedItems = flock_getTreeSelection($('list_view'), ["urlCol"]);

            var item = selectedItems[0];
            flock.browser.open(item["urlCol"], 'tab');
        },/*}}}*/
        cmd_shelfElementOpenInWindow: function () { /*{{{*/
            var selectedItems = flock_getTreeSelection($('list_view'), ["urlCol"]);

            var item = selectedItems[0];
            flock.browser.open(item["urlCol"], 'window');
        },/*}}}*/
        cmd_shelfElementOpenAllInTabs: function () {/*{{{*/
            var selectedItems = flock_getTreeSelection($('list_view'), ["urlCol"]);

            for (var i=0; i<selectedItems.length; i++){
                var item = selectedItems[i];
                flock.browser.open(item["urlCol"], 'tab');
            }
        },/*}}}*/
        cmd_selectAllShelf: function () { /*{{{*/
            var tree = $('list_view');
            tree.view.selection.selectAll();
        }/*}}}*/
    });
    // Add all the controllers to the right places/*{{{*/
    XXX("Add controllers (shelf)");
    $('list_view').controllers.appendController(treeController);
    /*}}}*/

    // Dispatch Clicks/*{{{*/
    var shelfTreeClicker = new flock.xul.TreeClicker(tree, {
        isDebug: false,
    });
    shelfTreeClicker.attach();/*}}}*/

    var shelfTree = new flock.xul.RDFTree(tree, {
        isDebug: false,
        
        isEditable: function (aResource) {/*{{{*/
            return true;
        },/*}}}*/
        
        clearDragData: function () {/*{{{*/
            XXX('clearingDragData');
            this.dragData = null;
            this.newDragData = true;
            
            this.dragProps = {};
        },/*}}}*/

        canDrop: function (aIndex, aOrientation) {/*{{{*/
            return true;
        },/*}}}*/
        onDrop: function (aRow, aOrientation) {/*{{{*/
        },/*}}}*/
        onSelectionChanged: function () {/*{{{*/
        },/*}}}*/
        onPerformActionOnCell: function (aAction, aRow, aCol) {/*{{{*/
            switch (aAction) {
                case "onDblClick": 
			goDoCommand('cmd_shelfElementOpen');
			break;
                case "onMdlClick":
                case "onDblCtrlClick":
                case "onDblMetaClick":
                    goDoCommand('cmd_shelfElementOpenInTab');
                    break;
            }
        },/*}}}*/
        onCycleCell: function (aRow, aCol) {/*{{{*/
            var rsrc = this.getResourceAtIndex(aRow);
	    var id = rsrc.Value.toString().split(":").pop();
            flock.shelf.service.remove(id);
        }/*}}}*/
    });
    shelfTree.attach();
    XXX("shelfTree is attached");

    // Context Menu
    var shelfContext = new flock.xul.SwitchingPopup($('shelfItemContext'), {
        isDebug: true,
        popupSet: "shelfElementContextPopupSet",
        onPopupShowing: function (aEvt) {/*{{{*/
            flock_updateCommandset($('flock_shelfElementCommands'));
            var tree = $('list_view');
            var count = tree.view.selection.count;
            if (count == 0) {
                return false;
            }
            else if (count == 1) {
                var treeSelection = flock_getTreeSelection(tree, ["typeCol"]);
                var item = treeSelection[0];
                if (item["typeCol"] == "note") {
                   $("menu-newtab").hidden = true;
                   $("menu-newwin").hidden = true;
                } else {
                   $("menu-newtab").hidden = false;
                   $("menu-newwin").hidden = false;
                }
                this.switchTo("shelfElementSelectedContext");
            }
            else {
                this.switchTo("shelfElementMultipleItemsSelectedContext");
            }
            return true;
        },/*}}}*/
    });
    shelfContext.attach();

    flock.shelf.service.AddObserver(shelfRdfObserver);

    $("icon-view").setListener(IconViewSlideyboxListener);

    // Switch to the background if the shelf is empty, and set the buttons checked/unchecked
    var shelfMode = $$("flock_TopbarShelfExtension").getAttribute("shelfmode");
    if(flock.shelf.service.elementsCount()==0){
	    $('shelf-deck').setAttribute('selectedIndex','0');
    } else {
	    $('shelf-deck').setAttribute('selectedIndex', shelfMode);
    }
    /* if (shelfMode == '1'){
       $$('flock-shelf-list').checked = true;
       $$('flock-shelf-icons').checked = false;
    } else {
       $$('flock-shelf-list').checked = false;
       $$('flock-shelf-icons').checked = true;
    } */
}

function delete_icon(){
   var aSelection = $('icon-view').getSelection();

   for(var i=0;i<aSelection.length;++i) {
       var child = aSelection[i].firstChild;
       flock.shelf.service.remove(child.id.split(':').pop());
   }
   
}

function open_icon(){
   var theObject = window.selected_shelfobject;
   if (theObject.type == "note") {
      window.openDialog("chrome://browser/content/flock/shelf/addShelfNoteDlg.xul", "addNote", "modal", theObject.id.split(':').pop());
   } else {
      flock.browser.open(theObject.url);
   }
}

function open_icon_tab(){
   var theUrl = window.selected_shelfobject.url;
   if (window.selected_shelfobject.type != "note") {
      flock.browser.open(theUrl, 'tab');
   }
}

function open_icon_window(){
   var theUrl = window.selected_shelfobject.url;
   if (window.selected_shelfobject.type != "note") {
      flock.browser.open(theUrl, 'window');
   }
}

function close_shelf(){
    flock.shelf.service.RemoveObserver(shelfRdfObserver);
}

function shelf_switch(mode){
    $$("flock_TopbarShelfExtension").setAttribute("shelfmode", mode);
    if (mode == '1') {
       $$('flock-shelf-list').checked = true;
       $$('flock-shelf-icons').checked = false;
    } else {
       $$('flock-shelf-list').checked = false;
       $$('flock-shelf-icons').checked = true;
    }
    redraw_shelf();
}

function add_object(data){
    var title;
    var url;
    var pos;

    // XXX Bad Hack: This is a relic from the old shelf. This will be much simplier when
    // I will be done with metadata (that can break other things,
    // including the Mini Mapper)
    switch(data.type){
        case 'document': title = data.label;
          	             url = data.header;
	                     break;
        default: title = data.header;
          	     url = data.label;
    }
    
    var shelfMode = $$("flock_TopbarShelfExtension").getAttribute("shelfmode");

    // XXX("shelfMode ", shelfMode);
    switch (shelfMode){
     case '2'  : var hoverChild = $("icon-view").hoverChild;
                 // for(var i in hoverChild){ XXX("hoverChild "+i, hoverChild[i]);}

	         if (hoverChild){
                    pos = flock.shelf.service.getPositionOf(hoverChild.firstChild.id);
                 } else {
                    pos = -1;
                 }
               break;
     default : pos = -1; // List view: insert at the end
    }
    // XXX('pos: ', pos);
    // Dragged from the shelf (icon view)
    if (data.dragfrom)
        flock.shelf.service.remove(data.dragfrom.split(":").pop());

    flock.shelf.service.insertOld(data.type, title, url, data.src, pos);
}

function flush_shelf(){
    flock.shelf.service.clear();
    $T('shelf-deck').setAttribute('selectedIndex','0');
}

function delete_selection(event){
    var tree = $('list_view');
    var selectedItems = flock_getTreeSelection(tree, ["idCol"]);

    for (var i = 0; i < selectedItems.length; ++i) {
        var item = selectedItems[i];
	var id = item["idCol"];
        flock.shelf.service.remove(id);
    }

}

function sendToShelf(event){
    var topWindow = flock_mostRecentNavigator();
    var node = topWindow.document.popupNode;

    var contentDetector = new nsContentDetector();
    contentDetector.setTarget(node);

    var data = new RichObject()

    var location = $$("content").mCurrentBrowser.contentWindow.location + "";
    var selection = flock.browser.getSelection();

    // XXX('selection ', selection);

    if(contentDetector.onImage) {
        // XXX('node ', node);
        data.type = "image";
        data.title = node.alt;
        data.src = '<img alt="' + node.alt + '"src="' + contentDetector.imageURL + '"/>';
        data.webPageUrl = contentDetector.imageURL;
    } else if (selection.toString().length > 0) {
        // Send selected text
        data.type = "document";
        data.title = selection; 
        data.src = '<blockquote cite="' + location + '">' + selection + "</blockquote>"
                      + '<p class="citation"><cite cite="' + location + '"><a href="' + location + '">' + title + '</a>' + "</cite></p><br/>";
        data.webPageUrl = location;
    } else {
        // Default: send a link to the current page
        data.type = "link";
        data.title = $$("content").mCurrentBrowser.contentWindow.document.title + "";
        data.src = '<a href="' + location + '">' + title + "</a>";
        data.webPageUrl = location;
    }
    dump("Send to shelf "+data.src+"\n");
    
    flock.shelf.service.insert(data, -1);
}

// This function doesn't really redraws, it just checks if we need
// to present the "Drop Stuff Here" message or the elements list
function redraw_shelf(){
    var eltCount = flock.shelf.service.elementsCount();
    var shelfMode = $$("flock_TopbarShelfExtension").getAttribute("shelfmode");

    if(eltCount==0){
	    $('shelf-deck').setAttribute('selectedIndex', '0');
    } else {
	    $('shelf-deck').setAttribute('selectedIndex', shelfMode);
    }
}


// The following functions are called in the scope of addShelfNoteDlg.xul

function add_note() {
    window.openDialog("chrome://browser/content/flock/shelf/addShelfNoteDlg.xul", "addNote", "modal");
}

function fillFields() {
   if (window.arguments) {
      var objId = window.arguments;
      $('note-content').value = flock.shelf.service.getTargetOf(objId, "title");
   }
}

function save_note() {
   var content = $('note-content').value;

   flock.shelf.service.insertOld('note', content, '', content, -1);
}


