// vim: foldmethod=marker

//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var gTopbarFavoritesDS;

function $T(aID) {
	return $("flock_TopbarBrowser").contentDocument.getElementById(aID);
}

function TopbarJSCtx() {
    return $$("flock_TopbarBrowser").contentWindow;
}

function flock_TopbarGetFavoritesDS() {
    // Return DS, create if an instance doesn't exist
    if(!gTopbarFavoritesDS) {
        gTopbarFavoritesDS = new RDFDataSource("rdf:flock-favorites");
    }
    return gTopbarFavoritesDS;
}

function flock_TopbarHideExtensionArea() {
    // show the main Extension UI
    $("flock_TopbarUIExtensionArea").removeAttribute("collapsed");
    // Collapse extension areas
    var extArea = $("flock_TopbarUIExtensionArea");
    for(var i=0;i<extArea.childNodes.length;++i) {
        extArea.childNodes.item(i).setAttribute("hidden", true);
    }
}

function flock_TopbarSelectCollection(aID) {
    var favsDS = flock_TopbarGetFavoritesDS();
    try {
        flock_getFavoritesService().setToolbarCollection(favsDS.getNode(aID).source);
        //annoyingly, the extID property doesn't want to stick.  shoving it on
        //every tme...
        $(aID).setAttribute('extID','flock_TopbarFavoritesToolbarExt');
        flock_topbarSelectById(aID);
//        $('flock_TopbarFavoritesToolbarExt').removeAttribute("hidden");
        flock_setCharPref("flock.topbar.lastCollection", aID);
        $('flock_TopbarFavoritesToolbarExt').updateView();
    }
    catch(e) {
        alert(e);
    }
}

function flock_TopbarCreateMenulist() {
    // Remove kids
    var popup = $("flock_TopbarMenuPopup");
    while(popup.childNodes.length) {
        popup.removeChild(popup.firstChild);
    }

    var menuitem = null;
    
    // Get the collections header.
    popup.appendChild(flock_TopbarGetMenulistHeader('flock_CollectionsLabelBroadcaster'));

    // Setup favorites
    var favsDS = flock_TopbarGetFavoritesDS();
    var collections = favsDS.getNode("http://flock.com/rdf#CollectionsRoot").getChildren();
    while(collections.hasMoreElements()) {
        var collection = collections.getNext();
        var label = collection.getTarget("http://home.netscape.com/NC-rdf#Name").getValue();
        var value = collection.getValue();
        menuitem = document.createElement("menuitem");
        popup.appendChild(menuitem);
        menuitem = popup.lastChild;
        menuitem.setAttribute("group", "collections");
        menuitem.setAttribute("label", label);
        menuitem.setAttribute("value", value);
        menuitem.setAttribute("id", value);
        menuitem.setAttribute("autocheck", false);
        menuitem.setAttribute("maxwidth", "175");
        menuitem.setAttribute("crop", "end");
        menuitem.setAttribute("oncommand", "flock_TopbarSelectCollection('" + value + "');");
    }
    // topbars header
    popup.appendChild(flock_TopbarGetMenulistHeader('flock_TopbarsLabelBroadcaster'));

    // Setup Topbars
    var set = $("flock_TopbarBroadcasterSet");
    for(var i=0;i<set.childNodes.length;++i) {
        var bcaster = set.childNodes.item(i); 
        menuitem = document.createElement("menuitem");
        menuitem.setAttribute("autocheck", false);
        menuitem.setAttribute("observes", bcaster.getAttribute("id"));
        popup.appendChild(menuitem);
    }

    // hack -- moving this attribute from favoritesToolbar.xml had unexplainable results
    // during construction of the bound element. will be invalid when bug #2049 is fixed
    if ($('flock_TopbarMenulist').hasAttribute('sizetopopup')) {
        $('flock_TopbarMenulist').setAttribute('sizetopopup', 'never');
    }

}

function flock_TopbarGetMenulistHeader(aBroadcaster) {
    var headerContainer;
    var hboxleft;
    var hboxright;
    var label;
     
    headerContainer = document.createElement('hbox');
    headerContainer.setAttribute('align', 'center');
    headerContainer.setAttribute('pack', 'center');
    
    hboxleft = document.createElement('hbox'); 
    hboxleft.setAttribute('width', '6');
    hboxleft.setAttribute('style', 'border-bottom: 1px solid #494949; margin-left: 4px;');
    
    hboxright = document.createElement('hbox'); 
    hboxright.setAttribute('flex', '1');
    hboxright.setAttribute('style', 'border-bottom: 1px solid #494949; margin-right: 4px;');
    
    label = document.createElement('label');
    label.setAttribute('observes', aBroadcaster);
    
    headerContainer.appendChild(hboxleft);
    headerContainer.appendChild(label);
    headerContainer.appendChild(hboxright);
    
    return headerContainer;
}

function flock_topbarSelectById(aID) {
    flock_topbarSelect($(aID));
}

function flock_TopbarGotoDefault() {
    var last = flock_getCharPref("flock.topbar.lastCollection");
    //select last collection
    if(last) {
        $("flock_TopbarMenulist").value = last;
        $("flock_TopbarMenulist").updateLabel();
        eval($("flock_TopbarMenulist").selectedItem.getAttribute("oncommand"));
    }
    else {
        // select default collection
        var defaultCollection = flock_getCharPref("flock.favorites.defaultCollection");
        if(defaultCollection) {
            var node = $("flock_TopbarMenulist").firstChild.firstChild;
            while(node) {
                if(node.getAttribute("group")=="collections") {
                    if(node.id==defaultCollection) {
                        flock_topbarSelect(node);
                        eval(node.getAttribute("oncommand"));// need to rework all this code, but not doing it now for fear of breaking a zillion topbars
                        break;
                    }
                }
                node = node.nextSibling;
            }
        }
        else {
            // select arbitrary collection collection
            var node = $("flock_TopbarMenulist").firstChild.firstChild;
            while(node) {
                if(node.getAttribute("group")=="collections") {
                    $("flock_TopbarMenulist").value = node.getAttribute("value");
                    $("flock_TopbarMenulist").updateLabel();
                    eval(node.getAttribute("oncommand"));
                    break;
                }
                node = node.nextSibling;
            }
        }
    }
}

function flock_topbarSelect(aObj) {
    aObj.value=
    $("flock_TopbarMenulist").value = aObj.getAttribute("value");
    $("flock_TopbarMenulist").updateLabel();
    
    flock_TopbarHideExtensionArea();

    // Setup extension area
    var extID = aObj.getAttribute("extID")
    if(extID) {
        if($(extID)) {
            $(extID).removeAttribute("hidden");
        }
        else {
            alert("Error! You havn't properly specified extID in your topbar");
        }
    }
    
	var topbarBrowser = $("flock_TopbarBrowser");
    var url = aObj.getAttribute("url")
    if(url) {
        if(url!=$("flock_TopbarBrowserContainer").getAttribute("src")) {
            if(topbarBrowser.getAttribute("src")) {
                try {
                    if(topbarBrowser.contentWindow.onunload) {
                        topbarBrowser.contentWindow.onunload();
                    }
                } catch(e) {
                }
            }
            var height = aObj.getAttribute("topbarHeight");
            if(height) {
                $("flock_TopbarBrowserContainer").setAttribute("height", height);
            }
            $("flock_TopbarBrowserContainer").removeAttribute("hidden");

            topbarBrowser.setAttribute("src", url);
        }
        else {
        }
    }

    else {
        $("flock_TopbarBrowserContainer").setAttribute("hidden", true);
        topbarBrowser.setAttribute("src", "");
    }
    var onselect = aObj.getAttribute("onselect")
    if(onselect) {
        eval(onselect);
    }
    var value = aObj.getAttribute("value");
}


