//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gBlogPrefCommandController = null;
var gSelectedBlog = null;


function flock_prefBlogLoad() {
    gBlogPrefCommandController = new CommandController();
    gBlogPrefCommandController.cmd_flock_blogPrefAddNotification = flock_blogPrefAddNotificationCommand;
    gBlogPrefCommandController.cmd_flock_blogPrefDelNotification = flock_blogPrefDelNotificationCommand;
    gBlogPrefCommandController.cmd_flock_blogEditAccount = flock_blogEditAccountCommand;
    gBlogPrefCommandController.cmd_flock_blogCreateAccount = flock_blogPrefCreateAccountCommand;
    gBlogPrefCommandController.cmd_flock_blogDeleteAccount = flock_blogDeleteAccountCommand;
    gBlogPrefCommandController.cmd_flock_blogEditAccount = flock_blogEditAccountCommand;

    window.controllers.appendController(gBlogPrefCommandController);
    window.focus();

    var ds = flock_blogGetSettings().ds;

    $("flock-blog-pref-notifications-listbox").database.AddDataSource(ds.getRawDataSource());
    $("flock-blog-pref-notifications-listbox").builder.rebuild();

//  $("flock-blog-pref-openpref").checked = flock_getBoolPref("flock.blog.editInTab");
    $("flock-blog-pref-notify").checked = flock_getBoolPref("flock.blog.notify");

    $("flock-blog-pref-accounts").database.AddDataSource(ds.getRawDataSource());
    $("flock-blog-pref-accounts").builder.rebuild();
}

function flock_blogPrefSelectAccount(aTarget) {
    if(aTarget) {
        gSelectedBlog = FLOCK_BLOG_RDF_SETTINGS  + ":" + aTarget.value;
        window.document.commandDispatcher.updateCommands('select'); 
    }
}

var flock_blogPrefAddNotificationCommand = {
    isEnabled: function() {
        return true;
    },
    exec: function() {
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
        var input = {value: ""};
        var check = {value: false};
        var title = flock_blogBundle().GetStringFromName("blog_pref_addnotif_title")
        var msg = flock_blogBundle().GetStringFromName("blog_pref_addnotif_msg")
        var result = prompts.prompt(window, title, msg, input, null, check);
        var blogSettings = flock_blogGetSettings();
        blogSettings.addNotification(input.value);
    },
}

var flock_blogDeleteAccountCommand = {
    isEnabled: function() {
        if(gSelectedBlog && gSelectedBlog.match(FLOCK_BLOG_DRAFTS_FOLDER)) return false;
        return gSelectedBlog != null;
    },
    exec: function() {
        var msg = flock_blogBundle().GetStringFromName("blog_pref_confirmdelete")
        if(confirm(msg)) {
            var blogSettings = flock_blogGetSettings();
            var blogAccount = blogSettings.getAccount(gSelectedBlog);
            blogSettings.deleteAccount(blogAccount);

            gSelectedBlog = null;
            gSelectedBlogIndex = null;
        }
    },
}

var flock_blogPrefCreateAccountCommand = {
    isEnabled: function() {
        return true;
    },
    exec: function() {
//        while ($("flock-blog-pref-accounts").getRowCount()) $("flock-blog-pref-accounts").removeItemAt(0);
        flock_blogOpenWizard();
       $("flock-blog-pref-accounts").builder.rebuild();
    },
}


var flock_blogEditAccountCommand = {
    isEnabled: function() {
        if(gSelectedBlog && gSelectedBlog.match(FLOCK_BLOG_DRAFTS_FOLDER)) return false;
        return gSelectedBlog != null;
    },
    exec: function() {
        window.openDialog("chrome://browser/content/flock/blog/blogAccountDlg.xul", "editAccount", "modal", gSelectedBlog); 
    },
}

var flock_blogPrefDelNotificationCommand = {
    isEnabled: function() {
        return true;
        return $("flock-blog-pref-notifications-listbox").selectedItem != null;
    },
    exec: function() {
        var toDelete = $("flock-blog-pref-notifications-listbox").selectedItem.value;
        var blogSettings = flock_blogGetSettings();
        blogSettings.removeNotification(toDelete);
    },
}

function flock_blogPrefOpenPref(obj) {
    flock_setBoolPref("flock.blog.editInTab", obj.checked);
}

function flock_blogPrefNotifyPref(obj) {
    flock_setBoolPref("flock.blog.notify", obj.checked);
}

