// vim: foldmethod=marker

/*
 * BEGIN FLOCK GPL
 * 
 * Copyright Flock Inc. 2005
 * http://flock.com
 * 
 * This file may be used under the terms of of the
 * GNU General Public License Version 2 or later (the "GPL"),
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * END FLOCK GPL
 */

const FLICKR_REST = "http://www.flickr.com/services/rest/?";
const FLICKR_APPID = "92c2a562f0e9c2ed8dfe78f42a7734c7";
const FLOCK_FLICKR_URN = "urn:flock:topbar:flickr";
const FLICKR_WIDTH = 140;

var _flickr = flock_getBundler("chrome://browser/locale/flock/topbar/topbar.properties");

/*
 ********************************************************************
 * FlickrJax Ajax extended class
 ********************************************************************
*/
var FlickrJax = function () {
    var me = this;
    me.rxml = null;
    me.onSuccess = function (aRes) {/*{{{*/
        me.rxml = aRes.responseXML;
        try {
            rxml = aRes.responseXML;
            rsp = rxml.getElementsByTagName("rsp")[0];
            if (rsp.getAttribute("stat") != "ok") {
                XXX("Got a fail response");
            /*
                err = rxml.getElementsByTagName("err")[0];
                XXX("ERR:"+err);
                throw new ApiError(err.getAttribute("code"), err.getAttribute("msg"));
             */
                me.handleError(e);
            } 
            else {
                XXX("Sending to Response callback");
                me.getCallback("Response")(me.transport);
            }
        } catch (e if e.name = "ApiError") {
            me.handleError(e);
        } catch (e) {
            XXX("E:"+e);
        }
    };/*}}}*/
    me.handleError = function (aError) {/*{{{*/
        
        XXX("ECODE:"+aError.code);
        XXX("EMSG:"+aError.message);
		$('flickrError').setAttribute('hidden',false);
		$('topbarFlickr-nav').setAttribute('hidden',true);
    };/*}}}*/
}
FlickrJax.prototype = new Ajax();


/*
 * Settings N Stuff
 */ 

var gFlickrSettings = null;
var gPageSize = 50;
function FlickrSettings() { }/*{{{*/
FlickrSettings.prototype = 
{
    page: 0,
    pages: 0,
    perPage: 0,
    total: 0,
    username: 0,
    userID: 0,
};/*}}}*/

function flock_flickrClearUser() {/*{{{*/
    gFlickrSettings = new FlickrSettings();
}/*}}}*/

function flock_flickrMakeReq(method, paramstring) {/*{{{*/
    var rval = FLICKR_REST + "method=" + method + "&";
    rval += "api_key=" + FLICKR_APPID + "&";
    rval += paramstring;
    XXX(rval);
    return rval;
}/*}}}*/

/*
 *  Scrolling Shizzle
 */

const FLICKR_SCROLL = 40;

function flock_flockrGetScrollX() {/*{{{*/
    var elm = $("topbarFlickr-scrollbox");
    var scrollbox = elm.boxObject.QueryInterface(Components.interfaces.nsIScrollBoxObject);
    
    var x = {};
    var y = {};
    scrollbox.getPosition(x,y);
    return x.value;
}/*}}}*/

var gScrollToPos = 0;
var gScrollDest = 0;

function flock_flickrScrollRight() {/*{{{*/
    gScrollDest = flock_flockrGetScrollX() + flock_flickrGetVisibleWidth();
    window.setTimeout("flock_flickrScroll();", 0);
}/*}}}*/
function flock_flickrScrollLeft() {/*{{{*/
    gScrollDest = flock_flockrGetScrollX() - flock_flickrGetVisibleWidth();
    if(gScrollDest<0) gScrollDest = 0;
    window.setTimeout("flock_flickrScroll();", 0);
}/*}}}*/
function flock_flickrGetVisibleWidth() {/*{{{*/
    var width =  $('topbarFlickr-scrollbox').boxObject.width;
    var scrollWidth = width - FLICKR_WIDTH;
    if(scrollWidth>20) return scrollWidth;
    return 20;
}/*}}}*/
function flock_flickrGetRealWidth() {/*{{{*/
    return document.getAnonymousNodes($('topbarFlickr-scrollbox'))[0].boxObject.width;
}/*}}}*/
function flock_flickrGetScrollBy() {/*{{{*/
    return FLICKR_SCROLL;
}/*}}}*/
function flock_flickrScroll() {/*{{{*/
    XXX('VISIBLE',flock_flickrGetVisibleWidth());
    XXX('REAL',flock_flickrGetRealWidth());

    var elm = $("topbarFlickr-scrollbox");
    var scrollbox = elm.boxObject.QueryInterface(Components.interfaces.nsIScrollBoxObject);
    
    if (scrollbox.width == 0) return;
    var x = {};
    var y = {};
    
    scrollbox.getPosition(x,y);
    
    var lastScrollPos = x.value;
  
 
    var keepScrolling = true;
    if (Math.abs(gScrollDest - x.value) < flock_flickrGetScrollBy()) { 
		dump('FLICKR CASE ONE\n');
        flock_scrollTo(scrollbox,gScrollDest,y.value);
    } else if (x.value < gScrollDest) { //
		dump('FLICKR CASE TWO\n');
        flock_scrollRight(scrollbox,flock_flickrGetScrollBy());
    } else if (x.value > gScrollDest) {
		dump('FLICKR CASE THREE\n');
        flock_scrollLeft(scrollbox,flock_flickrGetScrollBy());
    } else {
		dump('FLICKR CASE FOUR\n');
        XXX("DONE SCROLLING",x.value,y.value);
        keepScrolling = false;
    }

    scrollbox.getPosition(x, y);
    if (lastScrollPos == x.value) keepScrolling = false;

    if (flock_flickrShouldLoadMore(lastScrollPos)) {
        //flock_flickrGetPhotos(gFlickrSettings.userID,parseInt(gFlickrSettings.page) + 1);
        flock_flickrGetPhotos(gUser,gPage);
    }    

    if (keepScrolling) window.setTimeout("flock_flickrScroll();", 10);

	//The next few if blocks handle toggling the button states for the arrows.
	if(gScrollDest - FLICKR_SCROLL > 0){
		$('flock-flickr-scroll-left-button').setAttribute('disabled','false');
	} 
	if(gScrollDest - FLICKR_SCROLL <= 0){
		$('flock-flickr-scroll-left-button').setAttribute('disabled','true');
	}
	if (gScrollDest + flock_flickrGetVisibleWidth() + FLICKR_SCROLL >= flock_flickrGetRealWidth()){
		$('flock-flickr-scroll-right-button').setAttribute('disabled','true');
	}
	else{
		$('flock-flickr-scroll-right-button').setAttribute('disabled','false');
	}
}/*}}}*/

var gFlickrCurrentlyLoading = false;
function flock_flickrShouldLoadMore(aScrollPos) {/*{{{*/
    if (aScrollPos > flock_flickrGetRealWidth() - (flock_flickrGetVisibleWidth() * 2))
//            && parseInt(gFlickrSettings.page) < parseInt(gFlickrSettings.pages)
//            && !gFlickrCurrentlyLoading) {
    {
        return true;
    }
    return false;
}/*}}}*/

function flock_flickrShowPhotos() {/*{{{*/
    $('topbarFlickr-deck').selectedIndex = 1;
}/*}}}*/


/*
 * Data Manipulation
 */

var gFlickrDS = null;
function flock_flickrGetDS() {/*{{{*/
    if(!gFlickrDS) {
        var fileObj = flock_ensureRDF(FLOCK_FLICKR_URN+":photos","flock_flickr_photos.rdf");
        gFlickrDS = new RDFDataSource('file://'+fileObj.path);
    }
    return gFlickrDS;
}/*}}}*/
function flock_flickrGetCleanDS() {/*{{{*/
    gFlickrDS = flock_flickrGetDS();
//    var root = gFlickrDS.getNode(FLOCK_FLICKR_URN);
    gFlickrDS.deleteDescendents(FLOCK_FLICKR_URN+":photos");
    return gFlickrDS;
}/*}}}*/
function flock_flickrReset() {/*{{{*/
    flock_flickrGetCleanDS();
    var scrollbox = $('topbarFlickr-scrollbox');
    //scrollbox.builder.rebuild();
}/*}}}*/

/*
 * Utilities
 */
function _fns(str) {/*{{{*/
    return "http://www.flock.com/rdf/flickr/#" + str;
}/*}}}*/
function flock_flickrBuildPhotoUrl(server,id,secret,size) {/*{{{*/
    switch (size) {
        case "square": convertedSize = "_s"; break;
        case "thumbnail": convertedSize = "_t"; break;
        case "small": convertedSize = "_m"; break;
        case "medium": convertedSize = ""; break;
        case "large": convertedSize = "_b"; break;
        case "original": convertedSize = "_o"; break;
        default: convertedSize = "";
    }
    return "http://photos" + server + ".flickr.com/" + id + "_" + secret + convertedSize + ".jpg";
}/*}}}*/
function flock_flickrBuildPageUrl(aUserID,aPhotoId)  {/*{{{*/
    return "http://flickr.com/photos/"+aUserID+"/"+aPhotoId;
}/*}}}*/


/*
 *  Getting Photos
 * 
 */

var gLastID = null;
function _flock_flickrGetPhotos(aUserId, aPage) {/*{{{*/
	$('flickrError').setAttribute('hidden',true);
	$('topbarFlickr-nav').setAttribute('hidden',false);
    var req = new FlickrJax();
    if(!aPage) aPage = 1;

    gFlickrCurrentlyLoading = true;
    req.onResponse = flock_handleFlickrGetPhotosResponse;
    req.request(flock_flickrMakeReq("flickr.people.getPublicPhotos", "user_id=" + aUserId + "&per_page=" + gPageSize + "&page=" + aPage + "&extras=owner_name"));
}/*}}}*/
function flock_handleFlickrGetPhotosResponse(aRes) {/*{{{*/
    var rPhotos = aRes.responseXML.getElementsByTagName("photos")[0];
    gFlickrSettings.page = rPhotos.getAttribute("page");
    gFlickrSettings.pages = rPhotos.getAttribute("pages");
    gFlickrSettings.perPage = rPhotos.getAttribute("perpage");
    gFlickrSettings.total = rPhotos.getAttribute("total");
    
    var rPhotoList = rPhotos.getElementsByTagName("photo");
    var ds = flock_flickrGetDS();
    var root = ds.getNode(FLOCK_FLICKR_URN+":photos");
    root.makeSeq();
    for (i = 0; i < rPhotoList.length; i++) {
        var photo = rPhotoList[i];
        
        var id = photo.getAttribute("id");
        var server = photo.getAttribute("server");
        var secret = photo.getAttribute("secret");
        var title = photo.getAttribute("title");
        var owner_name = photo.getAttribute("ownername");
        var square_url = flock_flickrBuildPhotoUrl(server,id,secret,'square');
        var small_url = flock_flickrBuildPhotoUrl(server,id,secret,'small');
        var page_url = flock_flickrBuildPageUrl(gFlickrSettings.userID,id)

        var node = ds.getNode(FLOCK_FLICKR_URN+":photos:" + id);
        
        node.addTargetOnce(_fns('src'), square_url + "");
        node.addTargetOnce(_fns('smallURL'), small_url + "");
        node.addTargetOnce(_fns('id'), id + "");
        node.addTargetOnce(_fns('title'), title + "");
        node.addTargetOnce(_fns('pageURL'), page_url + "");
        root.addChild(node);
        gLastID = id;
    }    
    var ui = $("topbarFlickr-scrollbox");
    ui.ref = FLOCK_FLICKR_URN+":photos";
    ui.builder.rebuild();
    gFlickrCurrentlyLoading = false;
	if(rPhotoList.length > 0){
		$('flock-flickr-scroll-right-button').setAttribute('disabled','false');
	}
}/*}}}*/

/*
 *  Get User ID from Username
 */

var FlickrUserIdGetter = {
    onResult: function(aUser) {
        gUser = aUser;
        gPage = 1;
        this.inProgress = false;
        flock_flickrGetPhotos(aUser, gPage);
    },
    onError: function(aError) {
        this.inProgress = false;
        alert("got the error");
    },
    inProgress: false,
    exec: function(aUsername) {
        if(this.inProgress) return;
        this.inProgress = true;
        gAPI.findByUserName(this, aUsername);
    },
}

var FlickrPhotosGetter = {
    onResult: function(aResult) {
        //alert(aResult);
        this.inProgress = false;
        gPage++;
        try {
            flock_flickrProcess(aResult);
        }
        catch(e) {
            alert(e);
        }
    },
    onError: function(aError) {
        this.inProgress = false;
    },
    inProgress: false,
    exec: function(aUser, aPage) {
        if(this.inProgress) return;
        this.inProgress = true;
        gAPI.getPublicPhotos(this, aUser, gPageSize, aPage);
    },
}

var gAPI = null;
var gUser = null;
function flock_flickrGetUserID(aUsername) {/*{{{*/
    var constructor = flock_photoGetAPIConstructor();
    if(!gAPI) gAPI = new constructor();
    FlickrUserIdGetter.exec(aUsername);

}/*}}}*/

function flock_flickrProcess(aResult) {
    var ds = flock_flickrGetDS();
    var root = ds.getNode(FLOCK_FLICKR_URN+":photos");
    root.makeSeq();
    for (i = 0; i < aResult.length; i++) {
        var photo = aResult[i];
        
        var id = photo.id;
        var node = ds.getNode(FLOCK_FLICKR_URN+":photos:" + id);
        
        node.addTargetOnce(_fns('src'), photo.thumbnail + "");
        node.addTargetOnce(_fns('smallURL'), photo.midSizePhoto + "");
        node.addTargetOnce(_fns('title'), photo.title + "");
        node.addTargetOnce(_fns('pageURL'), photo.webPageUrl + "");
        root.addChild(node);
    }    
    var ui = $("topbarFlickr-scrollbox");
    ui.ref = FLOCK_FLICKR_URN+":photos";
    ui.builder.rebuild();
    gFlickrCurrentlyLoading = false;
	if(aResult.length > 0){
		$('flock-flickr-scroll-right-button').setAttribute('disabled','false');
	}
}

function flock_flickrGetPhotos(aUser, aPage) {
    FlickrPhotosGetter.exec(aUser,aPage);
/*
    var myListener = {
        onResult: function(aResult) {
            //alert(aResult);
            gRetrieving = false;
            gPage++;
            try {
            flock_flickrProcess(aResult);
            } catch(e) {
                alert(e);
            }
        },
        onError: function(aError) {
            gRetrieving = false;
        },
    }
    gRetrieving = true;
    gAPI.getPublicPhotos(myListener, aUser, gPageSize, aPage);
*/
}


function flock_handleFlickrGetUserIDResponse(aRes) {/*{{{*/
    flock_flickrClearUser();
    var rUser = aRes.responseXML.getElementsByTagName("user")[0];
    var rUsername = aRes.responseXML.getElementsByTagName("username")[0];
    var userID = rUser.getAttribute("id");

    gFlickrSettings.userID = userID
    gFlickrSettings.username = rUsername;
    flock_setCharPref("flock.flickr.userID",userID);
    flock_setCharPref("flock.flickr.username",rUsername.firstChild.nodeValue);

    flock_flickrReset();
    flock_flickrGetPhotos(userID);
//    flock_flickrShowPhotos();
}/*}}}*/


function flock_flickrUsernameSubmit(username) {/*{{{*/
    //var username = $("flock-flickr-username");
    flock_flickrGetUserID(username);
}/*}}}*/

function flickr_handleFocus(event){/*{{{*/
	dump('Focused flickr box\n');
}/*}}}*/

function flock_flickrInitUI() {/*{{{*/
    XXX("flickrInitUI");

    var ui = $("topbarFlickr-scrollbox");
    var ds = flock_flickrGetCleanDS();
//    var ds = flock_flickrGetDS();
    XXX("FLICKR DS",ds);
    ui.database.AddDataSource(ds.getRawDataSource());
    ui.ref = FLOCK_FLICKR_URN+":photos";
    ui.builder.rebuild();
    return;
    username = flock_getCharPref("flock.flickr.username");
//    username = "";
    if (username) {
        $('flock-flickr-username').value = username;
//		$('flock-flickr-scroll-right-button').setAttribute('disabled','false');
        flock_flickrGetUserID(username);        
    } else {
        username = "Join the Flock";
        $('flock-flickr-username').value = username;
        flock_flickrGetUserID(username);        
    }
    //gPageSize = 25;
}/*}}}*/

function flock_flickrInit() {/*{{{*/
    XXX("flock_flickrInit()");
//    flock_setFlag("browser_online",true);
	var box=$("topbarFlickr-box");
	box.addEventListener('keypress',flickr_handleKeypress,true);

    window.setTimeout("flock_flickrInitUI()",0);
}/*}}}*/

function flickr_handleKeypress(aEvent){/*{{{*/
    var ui = $$("topbarFlickr-scrollbox");
    switch(aEvent.keyCode){
        case aEvent.DOM_VK_LEFT:
            dump('FLICKR KEYPRESS LEFT\n');
            flock_flickrScrollLeft()
            break;
        case aEvent.DOM_VK_RIGHT:
            dump('FLICKR KEYPRESS RIGHT\n');
            flock_flickrScrollRight()
            break;
    }
}/*}}}*/

/*
 * DND Nation!
 */
var flickrDNDObserver = new DNDObserver();

flickrDNDObserver.onDragStart = function (aEvent, aXferData, aDragAction) {/*{{{*/
    try {
        var pageUrl = aEvent.target.pageURL;
        var html = aEvent.target.photoHTML;
        var title = aEvent.target.title;
        if (!title) {
            title = "";
        }
        XXX("url,html,title",pageUrl,html,title);
        aXferData.data = new TransferData();
        aXferData.data.addDataForFlavour("text/x-moz-url", pageUrl + "\n" + title);
        aXferData.data.addDataForFlavour("text/html", html);
    } catch (e) {
        XXX("ERROOORRROOROROROR",e);
    }
}/*}}}*/

flickrDNDObserver.getSupportedFlavours = function () {/*{{{*/
        var flavourSet = new FlavourSet();
        flavourSet.appendFlavour("text/x-moz-url");
        flavourSet.appendFlavour("text/html");
        return flavourSet;                           
}/*}}}*/

